namespace AddinExpress
{
    namespace AdvancedSearch
    {
        using System;
        using System.Runtime.InteropServices;
        using System.ComponentModel;
        using System.Windows.Forms;
        using IE = SHDocVw;
        using System.Text;
        using System.Diagnostics;
        using System.Collections;
        using System.Collections.Generic;
        using System.Reflection;

        /// <summary>
        /// Add-in Express .NET for Internet Explorer Bar
        /// </summary>
        [ComVisible(true), Guid("CD256139-EA4D-47E8-B37A-06369013CB6A")]
        public class AdvancedSearchIEBar : AddinExpress.IE.ADXIEBar
        {
            internal static bool BHOStarted = false;

            public AdvancedSearchIEBar()
            {
                Application.EnableVisualStyles();
                InitializeComponent();               
            }            
            public AdvancedSearchIEBar(int mode)
                : base(mode)
            {
                InitializeComponent();                
            }

            #region data

            private delegate void SetProgressDelegate(ProgressChangedEventArgs e);
            private delegate void EnableControlsDelegate(System.Boolean enable);
            private delegate void ShowResultsDelegate(TreeNode node);
            private bool firstStart = false;
            private SetProgressDelegate setProgress;
            private EnableControlsDelegate enableControls;
            private ShowResultsDelegate showResults;

            private TableLayoutPanel tableLayoutPanel1;
            private Label lblCaption;
            internal TextBox txtTerm;
            private Button btnFind;           
            private BackgroundWorker backgroundSearch;
            private TableLayoutPanel tableLayoutPanel2;
            private Button btnCancel;
            private TableLayoutPanel tableLayoutPanel3;
            private TabControl tabOptionsAndResults;
            private TabPage tabOptions;
            private TabPage tabResults;
            private LinkLabel linkToSite;
            private TableLayoutPanel tableLayoutPanel4;
            private TableLayoutPanel tableLayoutPanel5;
            private TableLayoutPanel tableLayoutPanel7;
            private TreeView treeResult;
            private Button btnHighlight;
            private GroupBox groupBox1;
            private GroupBox groupBox2;
            internal CheckBox checkTabs;
            internal CheckBox checkHidden;
            internal CheckBox checkWindows;
            private GroupBox groupBox3;
            internal CheckBox checkCase;
            internal CheckBox checkWholeWord;
            private Button btnSettings;
            private ProgressBar progressSearchBar;
            private ToolTip toolTip1;            
            SearchDescriptor SearchData;
            #endregion
            
            [DllImport("user32.dll")]
            [return: MarshalAs(UnmanagedType.Bool)]
            static extern bool IsWindowVisible(IntPtr hWnd);            

            #region Component Designer generated code
            /// <summary>
            /// Required by designer
            /// </summary>
            private System.ComponentModel.IContainer components;

            /// <summary>
            /// Required by designer support - do not modify
            /// the following method
            /// </summary>
            private void InitializeComponent()
            {
                this.components = new System.ComponentModel.Container();
                this.tableLayoutPanel1 = new System.Windows.Forms.TableLayoutPanel();
                this.lblCaption = new System.Windows.Forms.Label();
                this.txtTerm = new System.Windows.Forms.TextBox();
                this.tableLayoutPanel2 = new System.Windows.Forms.TableLayoutPanel();
                this.btnFind = new System.Windows.Forms.Button();
                this.btnCancel = new System.Windows.Forms.Button();
                this.tableLayoutPanel3 = new System.Windows.Forms.TableLayoutPanel();
                this.linkToSite = new System.Windows.Forms.LinkLabel();
                this.tabOptionsAndResults = new System.Windows.Forms.TabControl();
                this.tabOptions = new System.Windows.Forms.TabPage();
                this.tableLayoutPanel4 = new System.Windows.Forms.TableLayoutPanel();
                this.tableLayoutPanel5 = new System.Windows.Forms.TableLayoutPanel();
                this.progressSearchBar = new System.Windows.Forms.ProgressBar();
                this.btnSettings = new System.Windows.Forms.Button();
                this.groupBox1 = new System.Windows.Forms.GroupBox();
                this.groupBox3 = new System.Windows.Forms.GroupBox();
                this.checkCase = new System.Windows.Forms.CheckBox();
                this.checkWholeWord = new System.Windows.Forms.CheckBox();
                this.groupBox2 = new System.Windows.Forms.GroupBox();
                this.checkTabs = new System.Windows.Forms.CheckBox();
                this.checkHidden = new System.Windows.Forms.CheckBox();
                this.checkWindows = new System.Windows.Forms.CheckBox();
                this.tabResults = new System.Windows.Forms.TabPage();
                this.tableLayoutPanel7 = new System.Windows.Forms.TableLayoutPanel();
                this.treeResult = new System.Windows.Forms.TreeView();
                this.btnHighlight = new System.Windows.Forms.Button();
                this.backgroundSearch = new System.ComponentModel.BackgroundWorker();
                this.toolTip1 = new System.Windows.Forms.ToolTip(this.components);
                this.tableLayoutPanel1.SuspendLayout();
                this.tableLayoutPanel2.SuspendLayout();
                this.tableLayoutPanel3.SuspendLayout();
                this.tabOptionsAndResults.SuspendLayout();
                this.tabOptions.SuspendLayout();
                this.tableLayoutPanel4.SuspendLayout();
                this.tableLayoutPanel5.SuspendLayout();
                this.groupBox1.SuspendLayout();
                this.groupBox3.SuspendLayout();
                this.groupBox2.SuspendLayout();
                this.tabResults.SuspendLayout();
                this.tableLayoutPanel7.SuspendLayout();
                this.SuspendLayout();
                // 
                // tableLayoutPanel1
                // 
                this.tableLayoutPanel1.ColumnCount = 1;
                this.tableLayoutPanel1.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 100F));
                this.tableLayoutPanel1.Controls.Add(this.lblCaption, 0, 0);
                this.tableLayoutPanel1.Controls.Add(this.txtTerm, 0, 1);
                this.tableLayoutPanel1.Controls.Add(this.tableLayoutPanel2, 0, 2);
                this.tableLayoutPanel1.Controls.Add(this.tableLayoutPanel3, 0, 4);
                this.tableLayoutPanel1.Dock = System.Windows.Forms.DockStyle.Fill;
                this.tableLayoutPanel1.Location = new System.Drawing.Point(0, 0);
                this.tableLayoutPanel1.Name = "tableLayoutPanel1";
                this.tableLayoutPanel1.RowCount = 5;
                this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20F));
                this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 25F));
                this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 35F));
                this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle());
                this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 146F));
                this.tableLayoutPanel1.Size = new System.Drawing.Size(190, 494);
                this.tableLayoutPanel1.TabIndex = 0;
                // 
                // lblCaption
                // 
                this.lblCaption.Dock = System.Windows.Forms.DockStyle.Fill;
                this.lblCaption.Location = new System.Drawing.Point(3, 0);
                this.lblCaption.Name = "lblCaption";
                this.lblCaption.Size = new System.Drawing.Size(184, 20);
                this.lblCaption.TabIndex = 0;
                this.lblCaption.Text = "Please enter a text to find:";
                this.lblCaption.TextAlign = System.Drawing.ContentAlignment.BottomLeft;
                // 
                // txtTerm
                // 
                this.txtTerm.Dock = System.Windows.Forms.DockStyle.Fill;
                this.txtTerm.Location = new System.Drawing.Point(3, 23);
                this.txtTerm.Name = "txtTerm";
                this.txtTerm.Size = new System.Drawing.Size(184, 20);
                this.txtTerm.TabIndex = 0;
                this.txtTerm.KeyDown += new System.Windows.Forms.KeyEventHandler(this.txtTerm_KeyDown);
                // 
                // tableLayoutPanel2
                // 
                this.tableLayoutPanel2.ColumnCount = 2;
                this.tableLayoutPanel2.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50F));
                this.tableLayoutPanel2.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50F));
                this.tableLayoutPanel2.Controls.Add(this.btnFind, 0, 0);
                this.tableLayoutPanel2.Controls.Add(this.btnCancel, 1, 0);
                this.tableLayoutPanel2.Dock = System.Windows.Forms.DockStyle.Fill;
                this.tableLayoutPanel2.Location = new System.Drawing.Point(3, 48);
                this.tableLayoutPanel2.Name = "tableLayoutPanel2";
                this.tableLayoutPanel2.RowCount = 1;
                this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 100F));
                this.tableLayoutPanel2.Size = new System.Drawing.Size(184, 29);
                this.tableLayoutPanel2.TabIndex = 3;
                // 
                // btnFind
                // 
                this.btnFind.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                            | System.Windows.Forms.AnchorStyles.Left)
                            | System.Windows.Forms.AnchorStyles.Right)));
                this.btnFind.Location = new System.Drawing.Point(3, 3);
                this.btnFind.Name = "btnFind";
                this.btnFind.Size = new System.Drawing.Size(86, 23);
                this.btnFind.TabIndex = 2;
                this.btnFind.Text = "Find";
                this.btnFind.UseVisualStyleBackColor = true;
                this.btnFind.Click += new System.EventHandler(this.btnFind_Click);
                // 
                // btnCancel
                // 
                this.btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                            | System.Windows.Forms.AnchorStyles.Left)
                            | System.Windows.Forms.AnchorStyles.Right)));
                this.btnCancel.Enabled = false;
                this.btnCancel.Location = new System.Drawing.Point(95, 3);
                this.btnCancel.Name = "btnCancel";
                this.btnCancel.Size = new System.Drawing.Size(86, 23);
                this.btnCancel.TabIndex = 3;
                this.btnCancel.Text = "Cancel";
                this.btnCancel.UseVisualStyleBackColor = true;
                this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
                // 
                // tableLayoutPanel3
                // 
                this.tableLayoutPanel3.ColumnCount = 1;
                this.tableLayoutPanel3.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 100F));
                this.tableLayoutPanel3.Controls.Add(this.linkToSite, 0, 1);
                this.tableLayoutPanel3.Controls.Add(this.tabOptionsAndResults, 0, 0);
                this.tableLayoutPanel3.Dock = System.Windows.Forms.DockStyle.Fill;
                this.tableLayoutPanel3.Location = new System.Drawing.Point(3, 83);
                this.tableLayoutPanel3.Name = "tableLayoutPanel3";
                this.tableLayoutPanel3.RowCount = 2;
                this.tableLayoutPanel3.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 100F));
                this.tableLayoutPanel3.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20F));
                this.tableLayoutPanel3.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20F));
                this.tableLayoutPanel3.Size = new System.Drawing.Size(184, 408);
                this.tableLayoutPanel3.TabIndex = 4;
                // 
                // linkToSite
                // 
                this.linkToSite.AutoSize = true;
                this.linkToSite.Cursor = System.Windows.Forms.Cursors.Hand;
                this.linkToSite.Dock = System.Windows.Forms.DockStyle.Fill;
                this.linkToSite.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(204)));
                this.linkToSite.Location = new System.Drawing.Point(3, 388);
                this.linkToSite.Name = "linkToSite";
                this.linkToSite.Size = new System.Drawing.Size(178, 20);
                this.linkToSite.TabIndex = 10;
                this.linkToSite.TabStop = true;
                this.linkToSite.Text = "Add-in Express Ltd.";
                this.linkToSite.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
                this.linkToSite.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkToSite_LinkClicked);
                // 
                // tabOptionsAndResults
                // 
                this.tabOptionsAndResults.Controls.Add(this.tabOptions);
                this.tabOptionsAndResults.Controls.Add(this.tabResults);
                this.tabOptionsAndResults.Dock = System.Windows.Forms.DockStyle.Fill;
                this.tabOptionsAndResults.Location = new System.Drawing.Point(3, 3);
                this.tabOptionsAndResults.Name = "tabOptionsAndResults";
                this.tabOptionsAndResults.SelectedIndex = 0;
                this.tabOptionsAndResults.Size = new System.Drawing.Size(178, 382);
                this.tabOptionsAndResults.TabIndex = 9;
                // 
                // tabOptions
                // 
                this.tabOptions.Controls.Add(this.tableLayoutPanel4);
                this.tabOptions.Location = new System.Drawing.Point(4, 22);
                this.tabOptions.Name = "tabOptions";
                this.tabOptions.Padding = new System.Windows.Forms.Padding(3);
                this.tabOptions.Size = new System.Drawing.Size(170, 356);
                this.tabOptions.TabIndex = 0;
                this.tabOptions.Text = "Options";
                this.tabOptions.UseVisualStyleBackColor = true;
                // 
                // tableLayoutPanel4
                // 
                this.tableLayoutPanel4.ColumnCount = 1;
                this.tableLayoutPanel4.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle());
                this.tableLayoutPanel4.Controls.Add(this.tableLayoutPanel5, 0, 1);
                this.tableLayoutPanel4.Controls.Add(this.groupBox1, 0, 0);
                this.tableLayoutPanel4.Dock = System.Windows.Forms.DockStyle.Fill;
                this.tableLayoutPanel4.Location = new System.Drawing.Point(3, 3);
                this.tableLayoutPanel4.Name = "tableLayoutPanel4";
                this.tableLayoutPanel4.RowCount = 2;
                this.tableLayoutPanel4.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 180F));
                this.tableLayoutPanel4.RowStyles.Add(new System.Windows.Forms.RowStyle());
                this.tableLayoutPanel4.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20F));
                this.tableLayoutPanel4.Size = new System.Drawing.Size(164, 350);
                this.tableLayoutPanel4.TabIndex = 0;
                // 
                // tableLayoutPanel5
                // 
                this.tableLayoutPanel5.ColumnCount = 1;
                this.tableLayoutPanel5.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle());
                this.tableLayoutPanel5.Controls.Add(this.progressSearchBar, 0, 1);
                this.tableLayoutPanel5.Controls.Add(this.btnSettings, 0, 0);
                this.tableLayoutPanel5.Dock = System.Windows.Forms.DockStyle.Fill;
                this.tableLayoutPanel5.Location = new System.Drawing.Point(3, 183);
                this.tableLayoutPanel5.Name = "tableLayoutPanel5";
                this.tableLayoutPanel5.RowCount = 3;
                this.tableLayoutPanel5.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 30F));
                this.tableLayoutPanel5.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 30F));
                this.tableLayoutPanel5.RowStyles.Add(new System.Windows.Forms.RowStyle());
                this.tableLayoutPanel5.Size = new System.Drawing.Size(158, 164);
                this.tableLayoutPanel5.TabIndex = 21;
                // 
                // progressSearchBar
                // 
                this.progressSearchBar.Dock = System.Windows.Forms.DockStyle.Fill;
                this.progressSearchBar.Location = new System.Drawing.Point(3, 33);
                this.progressSearchBar.MarqueeAnimationSpeed = 0;
                this.progressSearchBar.Name = "progressSearchBar";
                this.progressSearchBar.Size = new System.Drawing.Size(152, 24);
                this.progressSearchBar.Style = System.Windows.Forms.ProgressBarStyle.Continuous;
                this.progressSearchBar.TabIndex = 25;
                this.progressSearchBar.Visible = false;
                // 
                // btnSettings
                // 
                this.btnSettings.Dock = System.Windows.Forms.DockStyle.Fill;
                this.btnSettings.Location = new System.Drawing.Point(3, 3);
                this.btnSettings.Name = "btnSettings";
                this.btnSettings.Size = new System.Drawing.Size(152, 24);
                this.btnSettings.TabIndex = 22;
                this.btnSettings.Text = "Settings";
                this.btnSettings.UseVisualStyleBackColor = true;
                this.btnSettings.Click += new System.EventHandler(this.btnSettings_Click);
                // 
                // groupBox1
                // 
                this.groupBox1.Controls.Add(this.groupBox3);
                this.groupBox1.Controls.Add(this.groupBox2);
                this.groupBox1.Dock = System.Windows.Forms.DockStyle.Fill;
                this.groupBox1.Location = new System.Drawing.Point(3, 3);
                this.groupBox1.Name = "groupBox1";
                this.groupBox1.Size = new System.Drawing.Size(158, 174);
                this.groupBox1.TabIndex = 22;
                this.groupBox1.TabStop = false;
                // 
                // groupBox3
                // 
                this.groupBox3.Controls.Add(this.checkCase);
                this.groupBox3.Controls.Add(this.checkWholeWord);
                this.groupBox3.Location = new System.Drawing.Point(7, 12);
                this.groupBox3.Name = "groupBox3";
                this.groupBox3.Size = new System.Drawing.Size(144, 64);
                this.groupBox3.TabIndex = 30;
                this.groupBox3.TabStop = false;
                this.groupBox3.Text = "Search options";
                // 
                // checkCase
                // 
                this.checkCase.AutoSize = true;
                this.checkCase.Location = new System.Drawing.Point(6, 42);
                this.checkCase.Name = "checkCase";
                this.checkCase.Size = new System.Drawing.Size(82, 17);
                this.checkCase.TabIndex = 22;
                this.checkCase.Text = "Match case";
                this.checkCase.UseVisualStyleBackColor = true;
                // 
                // checkWholeWord
                // 
                this.checkWholeWord.AutoSize = true;
                this.checkWholeWord.Location = new System.Drawing.Point(6, 19);
                this.checkWholeWord.Name = "checkWholeWord";
                this.checkWholeWord.Size = new System.Drawing.Size(135, 17);
                this.checkWholeWord.TabIndex = 21;
                this.checkWholeWord.Text = "Match whole word only";
                this.checkWholeWord.UseVisualStyleBackColor = true;
                // 
                // groupBox2
                // 
                this.groupBox2.Controls.Add(this.checkTabs);
                this.groupBox2.Controls.Add(this.checkHidden);
                this.groupBox2.Controls.Add(this.checkWindows);
                this.groupBox2.Location = new System.Drawing.Point(7, 82);
                this.groupBox2.Name = "groupBox2";
                this.groupBox2.Size = new System.Drawing.Size(143, 86);
                this.groupBox2.TabIndex = 29;
                this.groupBox2.TabStop = false;
                this.groupBox2.Text = "Look in";
                // 
                // checkTabs
                // 
                this.checkTabs.AutoSize = true;
                this.checkTabs.Enabled = false;
                this.checkTabs.Location = new System.Drawing.Point(6, 62);
                this.checkTabs.Name = "checkTabs";
                this.checkTabs.Size = new System.Drawing.Size(60, 17);
                this.checkTabs.TabIndex = 19;
                this.checkTabs.Text = "All tabs";
                this.toolTip1.SetToolTip(this.checkTabs, "Available when \'Quick Tabs\' is enabled.");
                this.checkTabs.UseVisualStyleBackColor = true;
                // 
                // checkHidden
                // 
                this.checkHidden.AutoSize = true;
                this.checkHidden.Location = new System.Drawing.Point(6, 16);
                this.checkHidden.Name = "checkHidden";
                this.checkHidden.Size = new System.Drawing.Size(99, 17);
                this.checkHidden.TabIndex = 23;
                this.checkHidden.Text = "Hidden content";
                this.checkHidden.UseVisualStyleBackColor = true;
                // 
                // checkWindows
                // 
                this.checkWindows.AutoSize = true;
                this.checkWindows.Location = new System.Drawing.Point(6, 39);
                this.checkWindows.Name = "checkWindows";
                this.checkWindows.Size = new System.Drawing.Size(81, 17);
                this.checkWindows.TabIndex = 20;
                this.checkWindows.Text = "All windows";
                this.toolTip1.SetToolTip(this.checkWindows, "Available when \'Quick Tabs\' is enabled.");
                this.checkWindows.UseVisualStyleBackColor = true;
                // 
                // tabResults
                // 
                this.tabResults.Controls.Add(this.tableLayoutPanel7);
                this.tabResults.Location = new System.Drawing.Point(4, 22);
                this.tabResults.Name = "tabResults";
                this.tabResults.Padding = new System.Windows.Forms.Padding(3);
                this.tabResults.Size = new System.Drawing.Size(170, 356);
                this.tabResults.TabIndex = 1;
                this.tabResults.Text = "Results";
                this.tabResults.UseVisualStyleBackColor = true;
                // 
                // tableLayoutPanel7
                // 
                this.tableLayoutPanel7.ColumnCount = 1;
                this.tableLayoutPanel7.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle());
                this.tableLayoutPanel7.Controls.Add(this.treeResult, 0, 0);
                this.tableLayoutPanel7.Controls.Add(this.btnHighlight, 0, 1);
                this.tableLayoutPanel7.Dock = System.Windows.Forms.DockStyle.Fill;
                this.tableLayoutPanel7.Location = new System.Drawing.Point(3, 3);
                this.tableLayoutPanel7.Name = "tableLayoutPanel7";
                this.tableLayoutPanel7.RowCount = 2;
                this.tableLayoutPanel7.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 100F));
                this.tableLayoutPanel7.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 30F));
                this.tableLayoutPanel7.Size = new System.Drawing.Size(164, 350);
                this.tableLayoutPanel7.TabIndex = 0;
                // 
                // treeResult
                // 
                this.treeResult.BackColor = System.Drawing.SystemColors.Window;
                this.treeResult.BorderStyle = System.Windows.Forms.BorderStyle.None;
                this.treeResult.Cursor = System.Windows.Forms.Cursors.Hand;
                this.treeResult.Dock = System.Windows.Forms.DockStyle.Fill;
                this.treeResult.Location = new System.Drawing.Point(3, 3);
                this.treeResult.Name = "treeResult";
                this.treeResult.Size = new System.Drawing.Size(158, 314);
                this.treeResult.TabIndex = 2;
                this.treeResult.NodeMouseDoubleClick += new System.Windows.Forms.TreeNodeMouseClickEventHandler(this.treeResult_NodeMouseDoubleClick);
                // 
                // btnHighlight
                // 
                this.btnHighlight.Dock = System.Windows.Forms.DockStyle.Fill;
                this.btnHighlight.Enabled = false;
                this.btnHighlight.Location = new System.Drawing.Point(3, 323);
                this.btnHighlight.Name = "btnHighlight";
                this.btnHighlight.Size = new System.Drawing.Size(158, 24);
                this.btnHighlight.TabIndex = 22;
                this.btnHighlight.Text = "Highlight";
                this.btnHighlight.UseVisualStyleBackColor = true;
                this.btnHighlight.Click += new System.EventHandler(this.btnHighlight_Click);
                // 
                // backgroundSearch
                // 
                this.backgroundSearch.WorkerReportsProgress = true;
                this.backgroundSearch.WorkerSupportsCancellation = true;
                this.backgroundSearch.DoWork += new System.ComponentModel.DoWorkEventHandler(this.backgroundSearch_DoWork);
                this.backgroundSearch.RunWorkerCompleted += new System.ComponentModel.RunWorkerCompletedEventHandler(this.backgroundSearch_RunWorkerCompleted);
                this.backgroundSearch.ProgressChanged += new System.ComponentModel.ProgressChangedEventHandler(this.backgroundSearch_ProgressChanged);
                // 
                // AdvancedSearchIEBar
                // 
                this.AutoScaleDimensions = new System.Drawing.SizeF(96F, 96F);
                this.Controls.Add(this.tableLayoutPanel1);
                this.MinimumSize = new System.Drawing.Size(190, 494);
                this.Name = "AdvancedSearchIEBar";
                this.Size = new System.Drawing.Size(190, 494);
                this.DownloadComplete += new AddinExpress.IE.ADXIEDownloadComplete_EventHandler(this.AdvancedSearchIEBar_DownloadComplete);
                this.OnSendMessage += new AddinExpress.IE.ADXIESendMessage_EventHandler(this.AdvancedSearchIEBar_OnSendMessage);
                this.OnBeforeDestroy += new System.EventHandler(this.AdvancedSearchIEBar_OnBeforeDestroy);
                this.OnConnect += new AddinExpress.IE.ADXIEConnect_EventHandler(this.AdvancedSearchIEBar_OnConnect);
                this.tableLayoutPanel1.ResumeLayout(false);
                this.tableLayoutPanel1.PerformLayout();
                this.tableLayoutPanel2.ResumeLayout(false);
                this.tableLayoutPanel3.ResumeLayout(false);
                this.tableLayoutPanel3.PerformLayout();
                this.tabOptionsAndResults.ResumeLayout(false);
                this.tabOptions.ResumeLayout(false);
                this.tableLayoutPanel4.ResumeLayout(false);
                this.tableLayoutPanel5.ResumeLayout(false);
                this.groupBox1.ResumeLayout(false);
                this.groupBox3.ResumeLayout(false);
                this.groupBox3.PerformLayout();
                this.groupBox2.ResumeLayout(false);
                this.groupBox2.PerformLayout();
                this.tabResults.ResumeLayout(false);
                this.tableLayoutPanel7.ResumeLayout(false);
                this.ResumeLayout(false);

            }
            #endregion

            #region ADX automatic code

            // Required by Add-in Express - do not modify
            // the methods within this region

            public override System.ComponentModel.IContainer GetContainer()
            {
                if (components == null)
                    components = new System.ComponentModel.Container();
                return components;
            }

            #endregion

            public IE.WebBrowser IEApp
            {
                get
                {
                    return (this.IEObj as IE.WebBrowser);
                }
            }

            public mshtml.HTMLDocument HTMLDocument
            {
                get
                {
                    return (this.HTMLDocumentObj as mshtml.HTMLDocument);
                }
            }

            public IEAdvancedSearch CurrentModule
            {
                get
                {
                    return this.Module as IEAdvancedSearch;
                }
            }

            public void InitializeAdvancedSearch()
            {
                setProgress = new SetProgressDelegate(this.SetProgressValue);
                enableControls = new EnableControlsDelegate(this.EnableControls);
                showResults = new ShowResultsDelegate(this.ShowSearchResult);
            }

            private void SetProgressValue(ProgressChangedEventArgs e)
            {
                if (e.ProgressPercentage != Const.None)
                {
                    progressSearchBar.Increment(e.ProgressPercentage - progressSearchBar.Value);
                }               
            }
            private void EnableControls(System.Boolean enabled)
            {
                checkCase.Enabled = enabled;
                checkHidden.Enabled = enabled;
                checkWholeWord.Enabled = enabled;
                checkWindows.Enabled = enabled;
                btnFind.Enabled = enabled;
                btnCancel.Enabled = !enabled;
                txtTerm.Enabled = enabled;
                if (enabled)
                {
                    progressSearchBar.Visible = false;
                    progressSearchBar.Value = 0;
                }
                else
                {
                    progressSearchBar.Visible = true;                    
                    tabOptionsAndResults.SelectTab(tabOptions);
                }
                if (treeResult.Nodes.Count > 0 && !checkHidden.Checked)
                {
                    btnHighlight.Enabled = true;
                }
                else
                {
                    btnHighlight.Enabled = false;
                }

                checkTabs.Enabled = ((this.IEVersion > 6) && enabled);
            }

            private void ShowSearchResult(TreeNode resultNode)
            {
                foreach (TreeNode node in resultNode.Nodes)
                {
                    treeResult.Nodes.Add(node);
                }
                treeResult.ExpandAll();
                treeResult.SelectedNode = treeResult.Nodes[0];
                tabOptionsAndResults.SelectTab(tabResults);
            }

            private void btnFind_Click(object sender, EventArgs e)
            {                
                if (txtTerm.Text.Trim() != String.Empty)
                {                    
                    treeResult.Nodes.Clear();                   
                    EnableControls(false);
                    SendMessageToAll(Const.WM_CLOSE_FORMS, IntPtr.Zero, IntPtr.Zero);

                    progressSearchBar.Visible = true;

                    SearchData = new SearchDescriptor();
                    SearchData.CheckCase = checkCase.Checked;
                    SearchData.CheckHidden = checkHidden.Checked;
                    SearchData.CheckTabs = checkTabs.Checked;
                    SearchData.CheckWholeWord = checkWholeWord.Checked;
                    SearchData.CheckWindows = checkWindows.Checked;
                    SearchData.Term = txtTerm.Text;

                    if (SearchData.Modules == null)
                        SearchData.Modules = new List<ModuleDescriptor>();
                    SearchData.Modules.Clear();

                    if (checkWindows.Checked)
                    {
                        IEAdvancedSearch m;

                        ArrayList modules =
                            AddinExpress.IE.ADXIEModule.GetModulesByTypeName(typeof(IEAdvancedSearch).FullName);

                        for (int i = 0; i < modules.Count; i++)
                        {                            
                            m = modules[i] as IEAdvancedSearch;
                            if (checkTabs.Checked)
                            {
                                ModuleDescriptor moduleDesc = new ModuleDescriptor();
                                moduleDesc.HTMLDoc =
                                    CreateHTMLDoc(m.GetHTMLText());
                                moduleDesc.MainWnd = m.MainWindowHandle;
                                moduleDesc.NativeWnd = m.NativeWindowHandle;
                                moduleDesc.TabWnd = m.ParentHandle;
                                moduleDesc.ThreadId = m.ThreadID;
                                SearchData.Modules.Add(moduleDesc);

                                if ((m.ThreadID == this.CurrentModule.ThreadID) &&
                                    (m.MainWindowHandle.ToInt64() == this.CurrentModule.MainWindowHandle.ToInt64()))
                                    SearchData.SearchModuleIndex = SearchData.Modules.Count - 1;
                            }
                            else
                            {
                                if (IsWindowVisible(m.ParentHandle))
                                {
                                    ModuleDescriptor moduleDesc = new ModuleDescriptor();
                                    moduleDesc.HTMLDoc =
                                        CreateHTMLDoc(m.GetHTMLText());
                                    moduleDesc.MainWnd = m.MainWindowHandle;
                                    moduleDesc.NativeWnd = m.NativeWindowHandle;
                                    moduleDesc.TabWnd = m.ParentHandle;
                                    moduleDesc.ThreadId = m.ThreadID;
                                    SearchData.Modules.Add(moduleDesc);

                                    if ((m.ThreadID == this.CurrentModule.ThreadID) &&
                                        (m.MainWindowHandle.ToInt64() == this.CurrentModule.MainWindowHandle.ToInt64()))
                                        SearchData.SearchModuleIndex = SearchData.Modules.Count - 1;
                                }
                            }
                        }
                    }
                    else if (checkTabs.Checked)
                    {
                        IEAdvancedSearch m;

                        for (int i = 0; i < this.Module.GetModuleCount(); i++)
                        {
                            m = this.Module.GetModuleByIndex(i) as IEAdvancedSearch;

                            if (m.MainWindowHandle == CurrentModule.MainWindowHandle)
                            {
                                ModuleDescriptor moduleDesc = new ModuleDescriptor();
                                moduleDesc.HTMLDoc =
                                    CreateHTMLDoc(m.GetHTMLText());
                                moduleDesc.MainWnd = m.MainWindowHandle;
                                moduleDesc.NativeWnd = m.NativeWindowHandle;
                                moduleDesc.TabWnd = m.ParentHandle;
                                moduleDesc.ThreadId = m.ThreadID;
                                SearchData.Modules.Add(moduleDesc);
                                if (m.ThreadID == this.CurrentModule.ThreadID)
                                    SearchData.SearchModuleIndex = SearchData.Modules.Count - 1;
                            }
                        }
                    }
                    else
                    {
                        ModuleDescriptor moduleDesc = new ModuleDescriptor();
                        moduleDesc.HTMLDoc =
                            CreateHTMLDoc(this.CurrentModule.GetHTMLText());
                        moduleDesc.MainWnd = this.CurrentModule.MainWindowHandle;
                        moduleDesc.NativeWnd = this.CurrentModule.NativeWindowHandle;
                        moduleDesc.TabWnd = this.CurrentModule.ParentHandle;
                        moduleDesc.ThreadId = this.CurrentModule.ThreadID;
                        SearchData.Modules.Add(moduleDesc);
                        SearchData.SearchModuleIndex = 0;
                    }

                    backgroundSearch.RunWorkerAsync(SearchData);
                }
            }

            private mshtml.HTMLDocument CreateHTMLDoc(string htmlText)
            {
                mshtml.HTMLDocument cloneDoc = null;

                cloneDoc = new mshtml.HTMLDocument();
                cloneDoc.open("text/html", "replace", null, null);
                cloneDoc.GetType().InvokeMember(
                    "write", BindingFlags.InvokeMethod, null, cloneDoc, new object[] { htmlText });

                return cloneDoc;
            }

            private void treeResult_NodeMouseDoubleClick(object sender, TreeNodeMouseClickEventArgs e)
            {
                if (e.Node.Level == 0) return;               
                CurrentModule.Navigate(e.Node);
            }

            private void txtTerm_KeyDown(object sender, KeyEventArgs e)
            {
                if (e.KeyCode == Keys.Enter)
                {
                    btnFind_Click(this, EventArgs.Empty);
                }
            }
           
            private void AdvancedSearchIEBar_OnBeforeDestroy(object sender, EventArgs e)
            {
                System.IntPtr ptrThread = new IntPtr(this.Module.ThreadID);
                this.SendMessageToAll(Const.WM_ITEM_CLOSED, ptrThread, IntPtr.Zero);
            }

            private void AdvancedSearchIEBar_OnSendMessage(AddinExpress.IE.ADXIESendMessageEventArgs e)
            {
                if (CurrentModule != null)
                {
                    if (e.Message == Const.WM_ITEM_CLOSED)
                    {
                        int threadID = e.WParam.ToInt32();
                        CurrentModule.RefreshTree(treeResult, threadID);
                    }                   
                }
            }
            private void backgroundSearch_DoWork(object sender, DoWorkEventArgs e)
            {
                try
                {                    
                    IEAdvancedSearch.Find(sender as BackgroundWorker, e);
                }
                catch
                {
                    System.Windows.Forms.MessageBox.Show(new WindowHandle(this.MainWindowHandle), "An unexpected error occured in the code of add-on.\n\rFor more information please try debugging the add-on.", 
                        "Advanced Search sample add-in for IE", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
            }

            private void backgroundSearch_ProgressChanged(object sender, ProgressChangedEventArgs e)
            {
                progressSearchBar.Invoke(setProgress, new object[] { e });
            }

            public void backgroundSearch_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
            {
                if (e.Error == null)
                {
                    if (!e.Cancelled)
                    {
                        TreeNode resultNode = ((SearchDescriptor)e.Result).ResultNode;

                        if (resultNode.Nodes.Count > Const.Ok)
                        {
                            this.Invoke(showResults, new object[] { resultNode });
                        }
                        else
                        {
                            System.Windows.Forms.MessageBox.Show(new WindowHandle(this.ParentHandle), "Text not found.", "Advanced search", MessageBoxButtons.OK, MessageBoxIcon.Information);
                        }
                    }

                    this.Invoke(enableControls, new object[] { true });
                }
            }
            private void btnCancel_Click(object sender, EventArgs e)
            {
                backgroundSearch.CancelAsync();
            }
            private void linkToSite_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
            {
                System.Object one = 0x0800;
                System.Object two = "_self";
                System.Object three = null;
                System.Object four = null;
                IEApp.Navigate("http://www.add-in-express.com", ref one, ref two, ref three, ref four);
            }
            private void btnHighlight_Click(object sender, EventArgs e)
            {
                ProgressForm progressForm = new ProgressForm();
                progressForm.Shown += new EventHandler(progressForm_Shown);
                progressForm.ShowDialog(new WindowHandle(ParentHandle));
                Button btn = sender as Button;
                if (btn != null)
                {
                    if (CurrentModule.IsHighlighted)
                    {
                        btn.Text = "Clear";
                        this.btnSettings.Enabled = false;
                    }
                    else
                    {
                        btn.Text = "Highlight";
                        this.btnSettings.Enabled = true;
                    }
                }
            }
            
            private void AdvancedSearchIEBar_OnConnect(object sender, int threadId)
            {               
                InitializeAdvancedSearch();
                EnableControls(AdvancedSearchIEBar.BHOStarted);

                if (AdvancedSearchIEBar.BHOStarted)
                    firstStart = true;
            }
           
            void progressForm_Shown(object sender, EventArgs e)
            {
                TreeNode root = new TreeNode();
                foreach (TreeNode node in treeResult.Nodes)
                {
                    root.Nodes.Add((TreeNode)node.Clone());
                }
                ProgressForm form = sender as ProgressForm;
                CurrentModule.Highlight(form, root, SearchData);
                form.DialogResult = DialogResult.OK;
            }

            private void btnSettings_Click(object sender, EventArgs e)
            {
                ((IEAdvancedSearch)this.Module).ShowSettings();
            }

            private void AdvancedSearchIEBar_DownloadComplete()
            {
                if (!firstStart)
                {
                    firstStart = true;
                    EnableControls(AdvancedSearchIEBar.BHOStarted);
                }
            }

        }
    }
}