namespace AddinExpress
{
    namespace AdvancedSearch
    {
        using System;
        using System.ComponentModel;
        using System.Windows.Forms;
        using System.IO;
        using IE = SHDocVw;
        using System.Text;
        using System.Collections.Generic;
        using AdvancedSearch;
        using System.Reflection;
        using System.Collections;
        using System.Runtime.Remoting;
        using System.Runtime.InteropServices;

        /// <summary>
        /// Add-in Express .NET for Internet Explorer Module
        /// </summary>
        [ComVisible(true), Guid("220CC1DD-1D13-40C1-97E0-07F042A2332A")]
        public class IEAdvancedSearch : AddinExpress.IE.ADXIEModule
        {            
            public IEAdvancedSearch()
            {
                InitializeComponent();
            }            
            public IEAdvancedSearch(IContainer container)
            {
                container.Add(this);
                InitializeComponent();
            }
            
            private AddinExpress.IE.ADXIEBarItem adxieAdvancedSearchBarItem;
            private AddinExpress.IE.ADXIEKeyboardShortcut adxieKeyboardCommand;           

            #region Component Designer generated code
            /// <summary>
            /// Required by designer
            /// </summary>
            private System.ComponentModel.IContainer components;

            /// <summary>
            /// Required by designer support - do not modify
            /// the following method
            /// </summary>
            private void InitializeComponent()
            {
                this.components = new System.ComponentModel.Container();
                this.adxieKeyboardCommand = new AddinExpress.IE.ADXIEKeyboardShortcut(this.components);
                this.adxieAdvancedSearchBarItem = new AddinExpress.IE.ADXIEBarItem(this.components);
                // 
                // adxieKeyboardCommand
                // 
                this.adxieKeyboardCommand.ShortcutText = "Ctrl+F";
                this.adxieKeyboardCommand.OnAction += new AddinExpress.IE.ADXIEKeyboardShortcut_EventHandler(this.adxieKeyboardCommand_OnAction);
                // 
                // adxieAdvancedSearchBarItem
                // 
                this.adxieAdvancedSearchBarItem.BarType = "AddinExpress.AdvancedSearch.AdvancedSearchIEBar";
                this.adxieAdvancedSearchBarItem.HelpText = "Add-in Express Advanced search engine";
                this.adxieAdvancedSearchBarItem.MaxSize = 200;
                this.adxieAdvancedSearchBarItem.MenuText = "Advanced Search (C#)";
                this.adxieAdvancedSearchBarItem.MinSize = 200;
                this.adxieAdvancedSearchBarItem.Title = "Advanced Search (C#)";
                // 
                // IEAdvancedSearch
                // 
                this.Bars.Add(this.adxieAdvancedSearchBarItem);
                this.HandleShortcuts = true;
                this.LoadInMainProcess = false;
                this.ModuleName = "AdvancedSearchForIE";
                this.OnConnect += new AddinExpress.IE.ADXIEConnect_EventHandler(this.IEAdvancedSearch_OnConnect);
                this.OnSendMessage += new AddinExpress.IE.ADXIESendMessage_EventHandler(this.IEAdvancedSearch_OnSendMessage);
                this.OnTabChanged += new AddinExpress.IE.ADXIETabChanged_EventHandler(this.IEAdvancedSearch_OnTabChanged);

            }
            #endregion

            #region ADX automatic code

            // Required by Add-in Express - do not modify
            // the methods within this region

            public override System.ComponentModel.IContainer GetContainer()
            {
                if (components == null)
                    components = new System.ComponentModel.Container();
                return components;
            }

            [ComRegisterFunctionAttribute]
            public static void RegisterIEModule(Type t)
            {
                AddinExpress.IE.ADXIEModule.RegisterIEModuleInternal(t);
            }

            [ComUnregisterFunctionAttribute]
            public static void UnregisterIEModule(Type t)
            {
                AddinExpress.IE.ADXIEModule.UnregisterIEModuleInternal(t);
            }

            [ComVisible(true)]
            public class IECustomContextMenuCommands :
                AddinExpress.IE.ADXIEModule.ADXIEContextMenuCommandDispatcher
            {
            }

            [ComVisible(true)]
            public class IECustomCommands :
                AddinExpress.IE.ADXIEModule.ADXIECommandDispatcher
            {

            }

            #endregion
            
            public IE.WebBrowser IEApp
            {
                get
                {
                    return (this.IEObj as IE.WebBrowser);
                }
            }

            public mshtml.HTMLDocument HTMLDocument
            {
                get
                {
                    return (this.HTMLDocumentObj as mshtml.HTMLDocument);
                }
            }

            public string GetHTMLText()
            {
                return HTMLDocument.documentElement.outerHTML;
            }

            private void adxieKeyboardCommand_OnAction(object sender)
            {                
                IEAdvancedSearch module = AddinExpress.IE.ADXIEModule.CurrentInstance[this.ThreadID] as IEAdvancedSearch;
                if (module != null)
                {
                    Type t = typeof(AdvancedSearchIEBar);
                    int index = module.Bars.IndexOf(t.FullName);
                    if (index >= 0)
                    {
                        AddinExpress.IE.ADXIEBarItem item = module.Bars[index];
                        object g = t.GUID.ToString("B");
                        object dummy = null;
                        if (item.BarObj == null)
                        {                            
                            object bShow = true;                            
                            IEApp.ShowBrowserBar(ref g, ref bShow, ref dummy);
                        }
                        else
                        {
                            AdvancedSearchIEBar dm = item.BarObj as AdvancedSearchIEBar;
                            if (dm != null)
                            {
                                if (!dm.Visible)
                                {                                    
                                    object bShow = true;                                    
                                    IEApp.ShowBrowserBar(ref g, ref bShow, ref dummy);
                                }
                                else
                                {
                                    object bShow = false;                                    
                                    IEApp.ShowBrowserBar(ref g, ref bShow, ref dummy);
                                }
                            }
                        }
                    }
                }

            }

            private void IEAdvancedSearch_OnConnect(object sender, int threadId)
            {
                AdvancedSearchIEBar.BHOStarted = true;
                this.adxieKeyboardCommand.ShortcutText = GlobalData.Instance.Settings.Shortcut;                
            }

            internal void ShowSettings()
            {
                AdvancedSearchSettings setForm = new AdvancedSearchSettings(GlobalData.Instance.Settings);
                switch (setForm.ShowDialog(new WindowHandle(ParentHandle)))
                {
                    case DialogResult.OK:
                        setForm.SynchronizeSettings();
                        GlobalData.Instance.SaveSettings();
                        break;
                    case DialogResult.Cancel:
                        setForm.DiscardSettings();
                        break;
                }
            }
            
            public AdvancedSearchIEBar IEBar
            {
                get
                {
                    return this.Bars[0].BarObj as AdvancedSearchIEBar;
                }              
            }
            
            [DllImport("user32.dll")]
            static extern bool ShowWindow(IntPtr hWnd, int cmdState);
            [DllImport("user32.dll")]
            static extern int SetForegroundWindow(IntPtr hWnd);
            [DllImport("user32.dll")]
            static extern bool IsIconic(IntPtr hWnd);
            [DllImport("user32.dll")]
            static extern bool IsWindow(IntPtr hWnd);
            [DllImport("user32", CharSet = CharSet.Auto)]
            public extern static int GetWindowText(IntPtr hWnd, StringBuilder lpString, int cch);
            [DllImport("user32.dll")]
            [return: MarshalAs(UnmanagedType.Bool)]
            static extern bool IsWindowVisible(IntPtr hWnd);
            
           
            public static void ShowFrame(IntPtr hWnd)
            {                
                SetForegroundWindow(hWnd);
                if (IsIconic(hWnd))
                    ShowWindow(hWnd, 9);
                else
                    ShowWindow(hWnd, 5);
            }
            
            bool isHighlighted = false;

            private int _line = 0;
            private int _position = 0;
            private HTMLForm form;
            
            private System.Boolean checkCase = default(bool);
            private System.Boolean checkHidden = default(bool);
            private System.Boolean checkWholeWord = default(bool);
            private System.Boolean checkTabs = default(bool);
            private System.Boolean checkWindows = default(bool);
            private System.String targetTerm = default(string);
            SearchFlags flags = SearchFlags.ieMatchPartialWords;

            private static System.ComponentModel.BackgroundWorker worker;
            private static System.ComponentModel.DoWorkEventArgs eventArgs;

            private bool needToShowTheForm = false;

            public static void Find(System.ComponentModel.BackgroundWorker backgroundWorker, System.ComponentModel.DoWorkEventArgs e)
            {                
                worker = backgroundWorker;
                eventArgs = e;

                SearchDescriptor searchData =
                    (SearchDescriptor)e.Argument;

                searchData.ResultNode = new TreeNode();

                if (searchData.CheckWindows)
                {
                    if (searchData.CheckTabs)
                    {
                        if (searchData.CheckHidden)
                        {
                            Search_Windows_Tabs_HTML(ref searchData);
                        }
                        else
                        {
                            Search_Windows_Tabs_Text(ref searchData);
                        }                        
                    }
                    else
                    {
                        if (searchData.CheckHidden)
                        {
                            Search_Windows_Tab_HTML(ref searchData);
                        }
                        else
                        {
                            Search_Windows_Tab_Text(ref searchData);
                        }                        
                    }
                }
                else
                {
                    if (searchData.CheckTabs)
                    {
                        if (searchData.CheckHidden)
                        {
                            Search_Window_Tabs_HTML(ref searchData);
                        }
                        else
                        {
                            Search_Window_Tabs_Text(ref searchData);
                        }                        
                    }
                    else
                    {
                        if (searchData.CheckHidden)
                        {
                            Search_Window_Tab_HTML(ref searchData);
                        }
                        else
                        {
                            Search_Window_Tab_Text(ref searchData);
                        }
                    }
                }

                e.Result = searchData;
            }

            public void Navigate(TreeNode node)
            {
                WindowInfoTag windowInfo = 
                    node.Parent.Tag as WindowInfoTag;
                if (windowInfo != null)
                {
                    
                    IEAdvancedSearch module = null;                     
                    IEAdvancedSearch m = null;
                        
                    ArrayList modules = 
                        AddinExpress.IE.ADXIEModule.GetModulesByTypeName(this.GetType().FullName);
                        
                    for (int i = 0; i < modules.Count; i++)
                    {
                        m = modules[i] as IEAdvancedSearch;
                        if ((m.NativeWindowHandle == windowInfo.NativeWindowHandle) && (m.MainWindowHandle.ToInt64() == windowInfo.HWND.ToInt64()))
                        {
                            module = m;
                            break;
                        }
                    }                

                    if (module != null)
                    {                       
                        if (node.Tag is int)
                        {
                            int position = (int)node.Tag;

                            if (IsWindow(windowInfo.HWND))
                            {
                                bool selectable = true;
                                if (!module.IsSelectableText(position, windowInfo.Term, (int)windowInfo.Flags))
                                {
                                    selectable = false;
                                    System.Windows.Forms.MessageBox.Show(new WindowHandle(this.ParentHandle),
                                        "Text cannot be highlighted. For example, it might be hidden.",
                                        "Advanced search", MessageBoxButtons.OK, MessageBoxIcon.Information);
                                }

                                if (selectable)
                                {                                        
                                    ShowFrame(windowInfo.HWND);
                                    if (!IsWindowVisible(module.ParentHandle))
                                        module.TabActivate();
                                }
                            }
                        } 
                                                
                        if (node.Tag is HtmlInfoTag)
                        {
                            SendMessageToAll(Const.WM_CLOSE_FORMS, IntPtr.Zero, IntPtr.Zero);
                            HtmlInfoTag htmlInfo = node.Tag as HtmlInfoTag;
                            if (htmlInfo != null)
                            {
                                if (IsWindow(windowInfo.HWND))
                                {
                                    ShowFrame(windowInfo.HWND);

                                    module.Line = htmlInfo.Line;
                                    module.Position = htmlInfo.Position;
                                    module.Term = windowInfo.Term;

                                    if (!IsWindowVisible(module.ParentHandle))
                                    {
                                        module.NeedToShowTheForm = true;
                                        module.TabActivate();
                                    }
                                    else
                                    {
                                        SendMessageToAll(Const.WM_SHOW_HTML_FORM, module.ParentHandle, IntPtr.Zero);
                                    }
                                }
                            }
                        }
                    }
                }
            }

            public bool IsSelectableText(int number, string term, int flags)
            {
                SearchFlags sFlags = (SearchFlags)flags;

                bool retValue = true;
                mshtml.IHTMLSelectionObject selectionObject = HTMLDocument.selection;
                mshtml.IHTMLTxtRange range = selectionObject.createRange() as mshtml.IHTMLTxtRange;
                mshtml.IHTMLElement elementBody = HTMLDocument.body;

                try
                {
                    range.moveToElementText(elementBody);
                }
                catch
                {                    
                    retValue = false;
                }

                for (int i = 1; i <= number; i++)
                {
                    range.findText(term, elementBody.innerText.Length, (int)sFlags);
                    range.moveStart("character", 1);
                }

                range.findText(term, elementBody.innerText.Length, (int)sFlags);

                Marshal.ReleaseComObject(selectionObject);
                Marshal.ReleaseComObject(elementBody);

                try
                {
                    range.select();
                    range.scrollIntoView(true);
                }
                catch
                {
                    retValue = false;
                }

                return retValue;
            }
            public void RefreshTree(TreeView tree, int threadID)
            {
                foreach (TreeNode node in tree.Nodes)
                {
                    WindowInfoTag tag = node.Tag as WindowInfoTag;
                    if (tag != null && tag.ThreadID == threadID)
                    {
                        tree.Nodes.Remove(node);
                    }
                }
            }
            private void UpdateProgress(int mainProgress, int position, int count)
            {
                int percent = System.Convert.ToInt32((System.Convert.ToDouble(position) / count) * 100);
                worker.ReportProgress(mainProgress, percent);
            }

            internal void Highlight(ProgressForm form, TreeNode resultNode, SearchDescriptor searchData)
            {
                int moduleCount = GetModuleCount();                
                IEAdvancedSearch module = null;
                for (int i = 0; i < resultNode.Nodes.Count; i++)
                {
                    int percent = System.Convert.ToInt32(System.Convert.ToDouble(i) / resultNode.Nodes.Count * 100);
                    TreeNode root = resultNode.Nodes[i];
                    WindowInfoTag wTag = root.Tag as WindowInfoTag;
                    try
                    {
                        module = GetModuleByThread(wTag.ThreadID) as IEAdvancedSearch;
                    }
                    catch { }
                    if (module != null)
                    {
                        foreach (TreeNode leaf in root.Nodes)
                        {
                            module.HighlightHtmlPageElements(isHighlighted, (int)leaf.Tag, (int)wTag.Flags, searchData.Term);
                            form.progressBar.Increment(percent - form.progressBar.Value);
                        }
                    }
                }                           

                form.progressBar.Value = 100;
                this.isHighlighted = !this.isHighlighted;
            }
            private void HighlightTextRange(mshtml.IHTMLTxtRange range, bool isHighlighted)
            {                
                GlobalSettings settings = GlobalData.Instance.Settings;
                if (settings != null)
                {
                    if (isHighlighted)
                    {
                        RemoveHTML(settings, range);
                    }
                    else
                    {
                        string htmlToInject = BuildHTML(settings, range);
                        if (!String.IsNullOrEmpty(htmlToInject))                        
                        {
                            range.pasteHTML(htmlToInject);
                        }
                    }
                }                
            }
            private String BuildHTML(GlobalSettings settings,mshtml.IHTMLTxtRange range)
            {
                string background = settings.BackgroundColor.R.ToString("X2") + settings.BackgroundColor.G.ToString("X2") + settings.BackgroundColor.B.ToString("X2");
                string textColor = settings.TextColor.R.ToString("X2") + settings.TextColor.G.ToString("X2") + settings.TextColor.B.ToString("X2");
                bool isEmpty = false;
                StringBuilder builder = new StringBuilder();
                builder.Append("<span id=advanced_search style=\"background:#");
                builder.Append(background);
                builder.Append("; color:#");
                builder.Append(textColor);
                builder.Append("\">");

                if (settings.IsHightlightNonVisible)
                {   
                    if (settings.IsItalic)
                    {
                        if (settings.IsBold)
                        {
                            builder.Append("<i><b>");
                            builder.Append(range.text);
                            builder.Append("</b></i></span>");
                        }
                        else
                        {
                            builder.Append("<i>");
                            builder.Append(range.text);
                            builder.Append("</i></span>");
                        }
                    }
                    else
                    {
                        if (settings.IsBold)
                        {
                            builder.Append("<b>");
                            builder.Append(range.text);
                            builder.Append("</b></span>");
                        }
                        else
                        {
                            builder.Append(range.text);
                            builder.Append("</span>");
                        }
                    }                    
                }
                else
                {
                    mshtml.IHTMLElement element = range.parentElement();
                    if (element.offsetTop > Const.NotFound && element.offsetLeft > Const.NotFound && element.offsetHeight > Const.Ok && element.offsetWidth > Const.Ok)
                    {
                        if (settings.IsItalic)
                        {
                            if (settings.IsBold)
                            {
                                builder.Append("<i><b>");
                                builder.Append(range.text);
                                builder.Append("</b></i></span>");
                            }
                            else
                            {
                                builder.Append("<i>");
                                builder.Append(range.text);
                                builder.Append("</i></span>");
                            }
                        }
                        else
                        {
                            if (settings.IsBold)
                            {
                                builder.Append("<b>");
                                builder.Append(range.text);
                                builder.Append("</b></span>");
                            }
                            else
                            {
                                builder.Append(range.text);
                                builder.Append("</span>");
                            }
                        }
                    }
                    else
                    {
                        isEmpty = true;
                    }
                    Marshal.ReleaseComObject(element);
                }
                if (isEmpty)
                {
                    return string.Empty;
                }
                else
                {
                    return builder.ToString();
                }
            }
            private void RemoveHTML(GlobalSettings settings, mshtml.IHTMLTxtRange range)
            {
                mshtml.IHTMLElement element = range.parentElement();
                if (settings.IsHightlightNonVisible)
                {
                    if (settings.IsBold)
                    {
                        if (settings.IsItalic)
                        {
                            RemoveBIS(element, range);
                        }
                        else
                        {
                            RemoveBS(element, range);
                        }
                    }
                    else
                    {
                        if (settings.IsItalic)
                        {
                            RemoveIS(element, range);                        
                        }
                        else
                        {
                            RemoveS(element, range);
                        }
                    }                   
                }
                else
                {
                    if (element.offsetTop > Const.NotFound && element.offsetLeft > Const.NotFound && element.offsetHeight > Const.Ok && element.offsetWidth > Const.Ok)
                    {
                        if (settings.IsBold)
                        {
                            if (settings.IsItalic)
                            {
                                RemoveBIS(element, range);
                            }
                            else
                            {
                                RemoveBS(element, range);
                            }
                        }
                        else
                        {
                            if (settings.IsItalic)
                            {
                                RemoveIS(element, range);
                            }
                            else
                            {
                                RemoveS(element, range);
                            }
                        }                        
                    }
                }
                Marshal.ReleaseComObject(element);
            }

            public void HighlightHtmlPageElements(bool isHighlighted,int position, int flags, string term)
            {      
                try
                {
                    this.targetTerm = term;                                 
                    mshtml.IHTMLSelectionObject selection = HTMLDocument.selection;
                    mshtml.IHTMLTxtRange range = selection.createRange() as mshtml.IHTMLTxtRange;                   

                    range.moveToElementText(HTMLDocument.body);
                    for (int index = 0; index < position; index++)
                    {
                        range.findText(term, 30000, flags);
                        range.moveStart("character", 1);
                    }
                    range.findText(term, 30000, flags);

                    HighlightTextRange(range, isHighlighted);

                    Marshal.ReleaseComObject(range);
                    range = null;
                    Marshal.ReleaseComObject(selection);
                    selection = null;                                    
                }
                catch(Exception ex)
                {
                    System.Diagnostics.Debug.WriteLine(ex.Message);
                }  
            }

            private void RemoveS(mshtml.IHTMLElement element, mshtml.IHTMLTxtRange range)
            {
                if (element.tagName == "SPAN" && element.getAttribute("id", 2).ToString() == "advanced_search")
                {
                    element.outerHTML = range.text; // this.targetTerm;
                }
            }
            private void RemoveIS(mshtml.IHTMLElement element, mshtml.IHTMLTxtRange range)
            {
                if (element.tagName == "I")
                {
                    mshtml.IHTMLElement elem = element.parentElement;
                    if (elem.tagName == "SPAN" && elem.getAttribute("id", 2).ToString() == "advanced_search")
                    {
                        elem.outerHTML = range.text; // this.targetTerm;
                    }
                    Marshal.ReleaseComObject(elem);
                }
            }
            private void RemoveBS(mshtml.IHTMLElement element, mshtml.IHTMLTxtRange range)
            {
                if (element.tagName == "B")
                {
                    mshtml.IHTMLElement elem = element.parentElement;
                    if (elem.tagName == "SPAN" && elem.getAttribute("id", 2).ToString() == "advanced_search")
                    {
                        elem.outerHTML = range.text; // this.targetTerm;
                    }
                    Marshal.ReleaseComObject(elem);
                }
            }
            private void RemoveBIS(mshtml.IHTMLElement element, mshtml.IHTMLTxtRange range)
            {
                if (element.tagName == "B")
                {
                    mshtml.IHTMLElement elem1 = element.parentElement;
                    if (elem1.tagName == "I")
                    {
                        mshtml.IHTMLElement elem2 = elem1.parentElement;
                        if (elem2.tagName == "SPAN" && elem2.getAttribute("id", 2).ToString() == "advanced_search")
                        {
                            elem2.outerHTML = range.text; // this.targetTerm;
                        }
                        Marshal.ReleaseComObject(elem2);
                    }
                    Marshal.ReleaseComObject(elem1);
                }
            }
            
            private static void Search_Window_Tab_HTML(ref SearchDescriptor searchData)
            {
                ModuleDescriptor moduleDesc = 
                    searchData.Modules[searchData.CurrentModuleIndex];

                if (moduleDesc.HTMLDoc != null)
                {
                    moduleDesc.Form = new HTMLForm();
                    moduleDesc.Form.Text = moduleDesc.HTMLDoc.title;
                    mshtml.IHTMLElement element = 
                        moduleDesc.HTMLDoc.documentElement;
                    moduleDesc.Form.richHtmlText.Text = element.outerHTML;

                    List<int> positions = null;
                    List<Node> nodes = new List<Node>();

                    Marshal.ReleaseComObject(element);

                    Root root = null;

                    if (CancelOperationOrReportUI((int)SearchProgress.Initializing)) 
                        return;

                    int length =
                        moduleDesc.Form.richHtmlText.Lines.Length;

                    if (searchData.CheckCase)
                    {
                        if (searchData.CheckWholeWord)
                        {
                            for (int line = 0; line < length; line++)
                            {
                                if ((positions = VisibleContent.CaseSensitive.WholeWord.AdvancedSearchEngine.Contains(moduleDesc.Form.richHtmlText.Lines[line], searchData.Term)).Count > Const.Ok)
                                {
                                    foreach (int pos in positions)
                                    {
                                        nodes.Add(new Node(moduleDesc.Form.richHtmlText.Lines[line], moduleDesc.Form.richHtmlText.Lines[line], 0, new HtmlInfoTag(line, pos)));
                                        if (IsCancelled) 
                                            return;
                                    }

                                    if (CancelOperationOrReportUI((int)SearchProgress.Searching, System.Convert.ToInt32((Convert.ToDouble(line) / length) * 100))) 
                                        return;
                                }
                            }

                            if (nodes.Count > Const.Ok)
                            {
                                root = new Root(moduleDesc.HTMLDoc.title, nodes, new WindowInfoTag(moduleDesc, searchData.Term, searchData.Flags));   
                            }
                        }
                        else
                        {
                            for (int line = 0; line < length; line++)
                            {
                                if ((positions = VisibleContent.CaseSensitive.WordAsPart.AdvancedSearchEngine.Contains(moduleDesc.Form.richHtmlText.Lines[line], searchData.Term)).Count > Const.Ok)
                                {
                                    foreach (int pos in positions)
                                    {
                                        nodes.Add(new Node(moduleDesc.Form.richHtmlText.Lines[line], moduleDesc.Form.richHtmlText.Lines[line], 0, new HtmlInfoTag(line, pos)));
                                        if (IsCancelled) 
                                            return;
                                    }

                                    if (CancelOperationOrReportUI((int)SearchProgress.Searching, System.Convert.ToInt32((Convert.ToDouble(line) / length) * 100))) 
                                        return;
                                }
                            }
                            if (nodes.Count > Const.Ok)
                            {
                                root = new Root(moduleDesc.HTMLDoc.title, nodes, new WindowInfoTag(moduleDesc, searchData.Term, searchData.Flags));  
                            }
                        }
                    }
                    else
                    {
                        if (searchData.CheckWholeWord)
                        {
                            for (int line = 0; line < length; line++)
                            {
                                if ((positions = VisibleContent.CaseInsensetive.WholeWord.AdvancedSearchEngine.Contains(moduleDesc.Form.richHtmlText.Lines[line], searchData.Term)).Count > Const.Ok)
                                {
                                    foreach (int pos in positions)
                                    {
                                        nodes.Add(new Node(moduleDesc.Form.richHtmlText.Lines[line], moduleDesc.Form.richHtmlText.Lines[line], 0, new HtmlInfoTag(line, pos)));
                                        if (IsCancelled) 
                                            return;
                                    }

                                    if (CancelOperationOrReportUI((int)SearchProgress.Searching, System.Convert.ToInt32((Convert.ToDouble(line) / length) * 100))) 
                                        return;
                                }
                            }
                            if (nodes.Count > Const.Ok)
                            {
                                root = new Root(moduleDesc.HTMLDoc.title, nodes, new WindowInfoTag(moduleDesc, searchData.Term, searchData.Flags));  
                            }
                        }
                        else
                        {
                            for (int line = 0; line < length; line++)
                            {
                                if ((positions = VisibleContent.CaseInsensetive.WordAsPart.AdvancedSearchEngine.Contains(moduleDesc.Form.richHtmlText.Lines[line], searchData.Term)).Count > Const.Ok)
                                {
                                    foreach (int pos in positions)
                                    {
                                        nodes.Add(new Node(moduleDesc.Form.richHtmlText.Lines[line], moduleDesc.Form.richHtmlText.Lines[line], 0, new HtmlInfoTag(line, pos)));
                                        if (IsCancelled) 
                                            return;
                                    }

                                    if (CancelOperationOrReportUI((int)SearchProgress.Searching, System.Convert.ToInt32((Convert.ToDouble(line) / length) * 100))) 
                                        return;
                                }
                            }
                            if (nodes.Count > Const.Ok)
                            {
                                root = new Root(moduleDesc.HTMLDoc.title, nodes, new WindowInfoTag(moduleDesc, searchData.Term, searchData.Flags));  
                            }
                        }
                    }

                    if (root != null)
                    {
                        TreeNode treeNode = 
                            new TreeNode(root.Title);
                        treeNode.Tag = root.WindowInfo;

                        List<TreeNode> treeNodes = 
                            new List<TreeNode>(root.Nodes.Count);

                        foreach (Node nodeInTheList in root.Nodes)
                        {
                            TreeNode leaf = new TreeNode(nodeInTheList.InnerText);
                            leaf.ToolTipText = nodeInTheList.ToolTipText;
                            leaf.Tag = nodeInTheList.HtmlTag;
                            treeNodes.Add(leaf);
                        }
                        treeNode.Nodes.AddRange(treeNodes.ToArray());
                        searchData.ResultNode.Nodes.Add(treeNode);
                    }

                    if (element != null) Marshal.ReleaseComObject(element);
                    element = null;

                    if (CancelOperationOrReportUI((int)SearchProgress.Done, SearchProgress.Done)) 
                        return;
                }
            }

            internal static void Search_Window_Tab_Text(ref SearchDescriptor searchData)
            {
                if (searchData.Modules.Count > 0)
                {
                    searchData.CurrentModuleIndex = 0;

                    mshtml.IHTMLElement element = searchData.Modules[searchData.CurrentModuleIndex].HTMLDoc.body;
                    if (element != null && !String.IsNullOrEmpty(element.innerText))
                    {
                        List<int> positions = null;

                        string body = element.innerText;
                        Marshal.ReleaseComObject(element);

                        if (CancelOperationOrReportUI((int)SearchProgress.Initializing)) 
                            return;

                        if (searchData.CheckCase)
                        {
                            if (searchData.CheckWholeWord)
                            {
                                positions = VisibleContent.CaseSensitive.WholeWord.AdvancedSearchEngine.Contains(body, searchData.Term);
                                searchData.Flags = SearchFlags.ieMatchCase | SearchFlags.ieMatchWholeWordsOnly;
                            }
                            else
                            {
                                positions = VisibleContent.CaseSensitive.WordAsPart.AdvancedSearchEngine.Contains(body, searchData.Term);
                                searchData.Flags = SearchFlags.ieMatchCase | SearchFlags.ieMatchPartialWords;
                            }
                        }
                        else
                        {
                            if (searchData.CheckWholeWord)
                            {
                                positions = VisibleContent.CaseInsensetive.WholeWord.AdvancedSearchEngine.Contains(body, searchData.Term);
                                searchData.Flags = SearchFlags.ieMatchWholeWordsOnly;
                            }
                            else
                            {
                                positions = VisibleContent.CaseInsensetive.WordAsPart.AdvancedSearchEngine.Contains(body, searchData.Term);
                                searchData.Flags = SearchFlags.ieMatchPartialWords;
                            }
                        }

                        if (CancelOperationOrReportUI((int)SearchProgress.Searching)) 
                          return;

                        Root moduleNode = CollectTextNodes(positions, ref searchData);

                        if (moduleNode != null)
                        {
                            TreeNode treeNode = new TreeNode(moduleNode.Title);
                            treeNode.Tag = moduleNode.WindowInfo;

                            List<TreeNode> treeNodes = 
                                new List<TreeNode>(moduleNode.Nodes.Count);

                            foreach (Node nodeInTheList in moduleNode.Nodes)
                            {
                                TreeNode leaf = new TreeNode(nodeInTheList.InnerText);
                                leaf.ToolTipText = nodeInTheList.ToolTipText;
                                leaf.Tag = nodeInTheList.Position;
                                treeNodes.Add(leaf);
                            }

                            treeNode.Nodes.AddRange(treeNodes.ToArray());
                            searchData.ResultNode.Nodes.Add(treeNode);
                        }

                        Marshal.ReleaseComObject(element);
                        element = null;

                        if (CancelOperationOrReportUI((int)SearchProgress.Done, (int)SearchProgress.Done)) 
                            return;
                    }
                }
            }

            private static void Search_Window_Tabs_HTML(ref SearchDescriptor searchData)
            {
                for (int currentModule = 0; currentModule < searchData.Modules.Count; currentModule++)
                {
                    searchData.CurrentModuleIndex = currentModule;

                    Root root = CollectHtmlNodes(ref searchData);
                    if (root != null)
                    {
                        TreeNode treeNode = new TreeNode(root.Title);
                        treeNode.Tag = root.WindowInfo;
                        List<TreeNode> treeNodes = new List<TreeNode>(root.Nodes.Count);
                        foreach (Node nodeInTheList in root.Nodes)
                        {
                            TreeNode leaf = new TreeNode(nodeInTheList.InnerText);
                            leaf.ToolTipText = nodeInTheList.ToolTipText;
                            leaf.Tag = nodeInTheList.HtmlTag;
                            treeNodes.Add(leaf);
                        }
                        treeNode.Nodes.AddRange(treeNodes.ToArray());
                        searchData.ResultNode.Nodes.Add(treeNode);
                    }

                    if (CancelOperationOrReportUI(System.Convert.ToInt32(System.Convert.ToDouble(currentModule) / searchData.Modules.Count * 100))) 
                        return;
                }
                
                if (CancelOperationOrReportUI((int)SearchProgress.Done, SearchProgress.Done)) 
                    return;
            }

            internal static void Search_Window_Tabs_Text(ref SearchDescriptor searchData)
            {
                for (int currentModule = 0; currentModule < searchData.Modules.Count; currentModule++)
                {
                    searchData.CurrentModuleIndex = currentModule;

                    Root moduleNode = 
                        Searching_Window_Tabs_Text(ref searchData);
                    if (moduleNode != null)
                    {
                        TreeNode treeNode = 
                            new TreeNode(moduleNode.Title);
                        treeNode.Tag = moduleNode.WindowInfo;

                        List<TreeNode> treeNodes = 
                            new List<TreeNode>(moduleNode.Nodes.Count);

                        foreach (Node nodeInTheList in moduleNode.Nodes)
                        {
                            TreeNode leaf = new TreeNode(nodeInTheList.InnerText);
                            leaf.ToolTipText = nodeInTheList.ToolTipText;
                            leaf.Tag = nodeInTheList.Position;
                            treeNodes.Add(leaf);
                        }

                        treeNode.Nodes.AddRange(treeNodes.ToArray());
                        searchData.ResultNode.Nodes.Add(treeNode);                        
                    }

                    if (CancelOperationOrReportUI(System.Convert.ToInt32(System.Convert.ToDouble(currentModule) / searchData.Modules.Count * 100))) 
                        return;
                }
                if (CancelOperationOrReportUI((int)SearchProgress.Done, SearchProgress.Done)) return;
            }

            private static void Search_Windows_Tabs_HTML(ref SearchDescriptor searchData)
            {
                for (int currentModule = 0; currentModule < searchData.Modules.Count; currentModule++)
                {
                    searchData.CurrentModuleIndex = currentModule;

                    Root root = CollectHtmlNodes(ref searchData);
                    if (root != null)
                    {
                        TreeNode treeNode = 
                            new TreeNode(root.Title);
                        treeNode.Tag = root.WindowInfo;

                        List<TreeNode> treeNodes = 
                            new List<TreeNode>(root.Nodes.Count);

                        foreach (Node nodeInTheList in root.Nodes)
                        {
                            TreeNode leaf = new TreeNode(nodeInTheList.InnerText);
                            leaf.ToolTipText = nodeInTheList.ToolTipText;
                            leaf.Tag = nodeInTheList.HtmlTag;
                            treeNodes.Add(leaf);
                        }

                        treeNode.Nodes.AddRange(treeNodes.ToArray());
                        searchData.ResultNode.Nodes.Add(treeNode);
                    }

                    if (CancelOperationOrReportUI(System.Convert.ToInt32(System.Convert.ToDouble(currentModule) / searchData.Modules.Count * 100))) 
                        return;
                }

                if (CancelOperationOrReportUI((int)SearchProgress.Done, SearchProgress.Done)) 
                    return;
            }

            private static void Search_Windows_Tabs_Text(ref SearchDescriptor searchData)
            {
                for (int currentModule = 0; currentModule < searchData.Modules.Count; currentModule++)
                {
                    searchData.CurrentModuleIndex = currentModule;

                    Root moduleNode = Searching_Windows_Tabs_Text(ref searchData);
                    if (moduleNode != null)
                    {
                        TreeNode treeNode = 
                            new TreeNode(moduleNode.Title);
                        treeNode.Tag = moduleNode.WindowInfo;

                        List<TreeNode> treeNodes = 
                            new List<TreeNode>(moduleNode.Nodes.Count);

                        foreach (Node nodeInTheList in moduleNode.Nodes)
                        {
                            TreeNode leaf = new TreeNode(nodeInTheList.InnerText);
                            leaf.ToolTipText = nodeInTheList.ToolTipText;
                            leaf.Tag = nodeInTheList.Position;
                            treeNodes.Add(leaf);
                        }

                        treeNode.Nodes.AddRange(treeNodes.ToArray());
                        searchData.ResultNode.Nodes.Add(treeNode);
                    }

                    if (CancelOperationOrReportUI(System.Convert.ToInt32(System.Convert.ToDouble(currentModule) / searchData.Modules.Count * 100))) 
                        return;
                }

                if (CancelOperationOrReportUI((int)SearchProgress.Done, (int)SearchProgress.Done)) 
                    return;
            }

            private static void Search_Windows_Tab_HTML(ref SearchDescriptor searchData)
            {
                for (int currentModule = 0; currentModule < searchData.Modules.Count; currentModule++)
                {
                    searchData.CurrentModuleIndex = currentModule;

                    if (IsWindowVisible(searchData.Modules[currentModule].TabWnd))
                    {
                        if (CancelOperationOrReportUI(System.Convert.ToInt32(System.Convert.ToDouble(currentModule) / searchData.Modules.Count * 100))) 
                            return;

                        Root root = CollectHtmlNodes(ref searchData);
                        if (root != null)
                        {
                            TreeNode treeNode = 
                                new TreeNode(root.Title);
                            treeNode.Tag = root.WindowInfo;

                            List<TreeNode> treeNodes = 
                                new List<TreeNode>(root.Nodes.Count);

                            foreach (Node nodeInTheList in root.Nodes)
                            {
                                TreeNode leaf = new TreeNode(nodeInTheList.InnerText);
                                leaf.ToolTipText = nodeInTheList.ToolTipText;
                                leaf.Tag = nodeInTheList.HtmlTag;
                                treeNodes.Add(leaf);
                            }

                            treeNode.Nodes.AddRange(treeNodes.ToArray());
                            searchData.ResultNode.Nodes.Add(treeNode);
                        }
                    }

                    if (CancelOperationOrReportUI(System.Convert.ToInt32(System.Convert.ToDouble(currentModule) / searchData.Modules.Count * 100))) 
                        return;
                }

                if (CancelOperationOrReportUI((int)SearchProgress.Done, SearchProgress.Done)) 
                    return;
            }

            internal static void Search_Windows_Tab_Text(ref SearchDescriptor searchData)
            {
                for (int currentModule = 0; currentModule < searchData.Modules.Count; currentModule++)
                {
                    searchData.CurrentModuleIndex = currentModule;

                    Root moduleNode = Searching_Windows_Tab_Text(ref searchData);
                    if (moduleNode != null)
                    {
                        TreeNode treeNode = 
                            new TreeNode(moduleNode.Title);
                        treeNode.Tag = moduleNode.WindowInfo;

                        List<TreeNode> treeNodes = 
                            new List<TreeNode>(moduleNode.Nodes.Count);

                        foreach (Node nodeInTheList in moduleNode.Nodes)
                        {
                            TreeNode leaf = new TreeNode(nodeInTheList.InnerText);
                            leaf.ToolTipText = nodeInTheList.ToolTipText;
                            leaf.Tag = nodeInTheList.Position;
                            treeNodes.Add(leaf);
                        }

                        treeNode.Nodes.AddRange(treeNodes.ToArray());
                        searchData.ResultNode.Nodes.Add(treeNode);
                    }

                    if (CancelOperationOrReportUI(System.Convert.ToInt32(System.Convert.ToDouble(currentModule) / searchData.Modules.Count * 100))) 
                        return;
                }

                if (CancelOperationOrReportUI((int)SearchProgress.Done, SearchProgress.Done)) 
                    return;
            }

            internal static Root Searching_Windows_Tabs_Text(ref SearchDescriptor searchData)
            {
                Root root = null;

                ModuleDescriptor moduleDesc = 
                    searchData.Modules[searchData.CurrentModuleIndex];

                if (moduleDesc.HTMLDoc != null)
                {
                    mshtml.IHTMLElement body = 
                        moduleDesc.HTMLDoc.body;
                    if (body != null && !String.IsNullOrEmpty(body.innerText))
                    {
                        List<int> positions = null;

                        if (searchData.CheckCase)
                        {
                            if (searchData.CheckWholeWord)
                            {
                                positions = VisibleContent.CaseSensitive.WholeWord.AdvancedSearchEngine.Contains(moduleDesc.HTMLDoc.body.innerText, searchData.Term);
                                searchData.Flags = SearchFlags.ieMatchCase | SearchFlags.ieMatchWholeWordsOnly;
                            }
                            else
                            {
                                positions = VisibleContent.CaseSensitive.WordAsPart.AdvancedSearchEngine.Contains(moduleDesc.HTMLDoc.body.innerText, searchData.Term);
                                searchData.Flags = SearchFlags.ieMatchCase | SearchFlags.ieMatchPartialWords;
                            }
                        }
                        else
                        {
                            if (searchData.CheckWholeWord)
                            {
                                positions = VisibleContent.CaseInsensetive.WholeWord.AdvancedSearchEngine.Contains(moduleDesc.HTMLDoc.body.innerText, searchData.Term);
                                searchData.Flags = SearchFlags.ieMatchWholeWordsOnly;
                            }
                            else
                            {
                                positions = VisibleContent.CaseInsensetive.WordAsPart.AdvancedSearchEngine.Contains(moduleDesc.HTMLDoc.body.innerText, searchData.Term);
                                searchData.Flags = SearchFlags.ieMatchPartialWords;
                            }
                        }

                        root = CollectTextNodes(positions, ref searchData);

                        Marshal.ReleaseComObject(body);
                        body = null;
                    }
                }

                return root;
            }

            internal static Root Searching_Windows_Tab_Text(ref SearchDescriptor searchData)
            {
                Root root = null;

                ModuleDescriptor moduleDesc = 
                    searchData.Modules[searchData.CurrentModuleIndex];

                if (IsWindowVisible(moduleDesc.MainWnd))
                {
                    if (moduleDesc.HTMLDoc != null)
                    {
                        mshtml.IHTMLElement body = 
                            moduleDesc.HTMLDoc.body;

                        if (body != null && !String.IsNullOrEmpty(body.innerText))
                        {
                            List<int> positions = null;

                            if (searchData.CheckCase)
                            {
                                if (searchData.CheckWholeWord)
                                {
                                    positions = VisibleContent.CaseSensitive.WholeWord.AdvancedSearchEngine.Contains(moduleDesc.HTMLDoc.body.innerText, searchData.Term);
                                    searchData.Flags = SearchFlags.ieMatchCase | SearchFlags.ieMatchWholeWordsOnly;
                                }
                                else
                                {
                                    positions = VisibleContent.CaseSensitive.WordAsPart.AdvancedSearchEngine.Contains(moduleDesc.HTMLDoc.body.innerText, searchData.Term);
                                    searchData.Flags = SearchFlags.ieMatchCase | SearchFlags.ieMatchPartialWords;
                                }
                            }
                            else
                            {
                                if (searchData.CheckWholeWord)
                                {
                                    positions = VisibleContent.CaseInsensetive.WholeWord.AdvancedSearchEngine.Contains(moduleDesc.HTMLDoc.body.innerText, searchData.Term);
                                    searchData.Flags = SearchFlags.ieMatchWholeWordsOnly;
                                }
                                else
                                {
                                    positions = VisibleContent.CaseInsensetive.WordAsPart.AdvancedSearchEngine.Contains(moduleDesc.HTMLDoc.body.innerText, searchData.Term);
                                    searchData.Flags = SearchFlags.ieMatchPartialWords;
                                }
                            }

                            root = CollectTextNodes(positions, ref searchData);

                            Marshal.ReleaseComObject(body);
                            body = null;
                        }
                    }
                }

                return root;
            }

            internal static Root Searching_Window_Tabs_Text(ref SearchDescriptor searchData)
            {
                Root root = null;
                List<int> positions = null;

                ModuleDescriptor moduleDesc = 
                    searchData.Modules[searchData.CurrentModuleIndex];

                mshtml.IHTMLElement body = moduleDesc.HTMLDoc.body;
                if (body != null && !String.IsNullOrEmpty(body.innerText))
                {
                    if (searchData.CheckCase)
                    {
                        if (searchData.CheckWholeWord)
                        {
                            positions = VisibleContent.CaseSensitive.WholeWord.AdvancedSearchEngine.Contains(moduleDesc.HTMLDoc.body.innerText, searchData.Term);
                            searchData.Flags = SearchFlags.ieMatchCase | SearchFlags.ieMatchWholeWordsOnly;
                        }
                        else
                        {
                            positions = VisibleContent.CaseSensitive.WordAsPart.AdvancedSearchEngine.Contains(moduleDesc.HTMLDoc.body.innerText, searchData.Term);
                            searchData.Flags = SearchFlags.ieMatchCase | SearchFlags.ieMatchPartialWords;
                        }
                    }
                    else
                    {
                        if (searchData.CheckWholeWord)
                        {
                            positions = VisibleContent.CaseInsensetive.WholeWord.AdvancedSearchEngine.Contains(moduleDesc.HTMLDoc.body.innerText, searchData.Term);
                            searchData.Flags = SearchFlags.ieMatchWholeWordsOnly;
                        }
                        else
                        {
                            positions = VisibleContent.CaseInsensetive.WordAsPart.AdvancedSearchEngine.Contains(moduleDesc.HTMLDoc.body.innerText, searchData.Term);
                            searchData.Flags = SearchFlags.ieMatchPartialWords;
                        }
                    }

                    root = CollectTextNodes(positions, ref searchData);

                    Marshal.ReleaseComObject(body);
                    body = null;
                }

                return root;
            }

            private static Root CollectTextNodes(List<int> pos, ref SearchDescriptor searchData)
            {
                Root root = null;

                if (pos == null) 
                    return root;

                ModuleDescriptor moduleDesc = 
                    searchData.Modules[searchData.CurrentModuleIndex];
                mshtml.IHTMLElement documentElement =
                    moduleDesc.HTMLDoc.documentElement;
                if (documentElement != null && !String.IsNullOrEmpty(documentElement.outerHTML))
                {
                    List<Node> nodes = new List<Node>();
                    mshtml.IHTMLTxtRange range = null;

                    for (int position = 0; position < pos.Count; position++)
                    {
                        mshtml.IHTMLSelectionObject sel = 
                            moduleDesc.HTMLDoc.selection;

                        if (sel != null)
                        {
                            sel.empty();
                            Marshal.ReleaseComObject(sel);
                        }

                        mshtml.IHTMLSelectionObject selectionObject = 
                            moduleDesc.HTMLDoc.selection;

                        mshtml.IHTMLElement bodyElement = 
                            moduleDesc.HTMLDoc.body;

                        range = 
                            selectionObject.createRange() as mshtml.IHTMLTxtRange;
                        range.moveToElementText(bodyElement);

                        for (int i = 1; i <= position; i++)
                        {
                            range.findText(searchData.Term, bodyElement.innerText.Length, (int)searchData.Flags);
                            range.moveStart("character", 1);
                        }

                        range.findText(searchData.Term, bodyElement.innerText.Length, (int)searchData.Flags);
                        mshtml.IHTMLElement parentElement = range.parentElement();

                        Node node = new Node(parentElement.innerText, moduleDesc.HTMLDoc.title, position, null);
                        nodes.Add(node);

                        Marshal.ReleaseComObject(parentElement);
                        parentElement = null;
                        Marshal.ReleaseComObject(bodyElement);
                        bodyElement = null;
                        Marshal.ReleaseComObject(selectionObject);
                        selectionObject = null;
                        Marshal.ReleaseComObject(range);
                        range = null;
                    }

                    if (nodes.Count > Const.Ok)
                        root = new Root(moduleDesc.HTMLDoc.title, nodes, new WindowInfoTag(moduleDesc, searchData.Term, searchData.Flags));                    

                    Marshal.ReleaseComObject(documentElement);                       
                    documentElement = null;                        
                }
                return root;
            }

            internal static Root CollectHtmlNodes(ref SearchDescriptor searchData)
            {                
                Root root = null;
                List<int> positions = null;
                List<Node> nodes = new List<Node>();

                ModuleDescriptor moduleDesc = 
                    searchData.Modules[searchData.CurrentModuleIndex];
                moduleDesc.Form = new HTMLForm();

                try
                {
                    if (moduleDesc.HTMLDoc != null)
                    {
                        moduleDesc.Form.Text = moduleDesc.HTMLDoc.title;

                        mshtml.IHTMLElement documentElement =
                            moduleDesc.HTMLDoc.documentElement;
                        if (documentElement != null && !String.IsNullOrEmpty(documentElement.outerHTML))
                        {
                            moduleDesc.Form.richHtmlText.Text =
                                documentElement.outerHTML;
                            int length =
                                moduleDesc.Form.richHtmlText.Lines.Length;

                            for (int line = 0; line < length; line++)
                            {
                                if (searchData.CheckCase)
                                {
                                    if (searchData.CheckWholeWord)
                                    {
                                        if ((positions = VisibleContent.CaseSensitive.WholeWord.AdvancedSearchEngine.Contains(moduleDesc.Form.richHtmlText.Lines[line], searchData.Term)).Count > Const.Ok)
                                        {
                                            foreach (int pos in positions)
                                            {
                                                nodes.Add(new Node(moduleDesc.Form.richHtmlText.Lines[line], moduleDesc.Form.richHtmlText.Lines[line], 0, new HtmlInfoTag(line, pos)));
                                            }
                                        }
                                    }
                                    else
                                    {
                                        if ((positions = VisibleContent.CaseSensitive.WordAsPart.AdvancedSearchEngine.Contains(moduleDesc.Form.richHtmlText.Lines[line], searchData.Term)).Count > Const.Ok)
                                        {
                                            foreach (int pos in positions)
                                            {
                                                nodes.Add(new Node(moduleDesc.Form.richHtmlText.Lines[line], moduleDesc.Form.richHtmlText.Lines[line], 0, new HtmlInfoTag(line, pos)));
                                            }
                                        }
                                    }
                                }
                                else
                                {
                                    if (searchData.CheckWholeWord)
                                    {
                                        if ((positions = VisibleContent.CaseInsensetive.WholeWord.AdvancedSearchEngine.Contains(moduleDesc.Form.richHtmlText.Lines[line], searchData.Term)).Count > Const.Ok)
                                        {
                                            foreach (int pos in positions)
                                            {
                                                nodes.Add(new Node(moduleDesc.Form.richHtmlText.Lines[line], moduleDesc.Form.richHtmlText.Lines[line], 0, new HtmlInfoTag(line, pos)));
                                            }
                                        }
                                    }
                                    else
                                    {
                                        if ((positions = VisibleContent.CaseInsensetive.WordAsPart.AdvancedSearchEngine.Contains(moduleDesc.Form.richHtmlText.Lines[line], searchData.Term)).Count > Const.Ok)
                                        {
                                            foreach (int pos in positions)
                                            {
                                                nodes.Add(new Node(moduleDesc.Form.richHtmlText.Lines[line], moduleDesc.Form.richHtmlText.Lines[line], 0, new HtmlInfoTag(line, pos)));
                                            }
                                        }
                                    }
                                }
                            }

                            if (nodes.Count > Const.Ok)
                                root = new Root(moduleDesc.HTMLDoc.title, nodes, new WindowInfoTag(moduleDesc, searchData.Term, searchData.Flags));

                            Marshal.ReleaseComObject(documentElement);
                            documentElement = null;
                        }
                    }

                }
                finally
                {
                    if (moduleDesc.Form != null)
                    {
                        moduleDesc.Form.Dispose();
                        moduleDesc.Form = null;
                    }
                }

                return root;
            }         
          
          
            
            private static bool CancelOperationOrReportUI(int percent, object userState)
            {
                bool interrupted = false;
                if (worker.CancellationPending)
                {
                    eventArgs.Cancel = true;
                    interrupted = true;
                }
                else
                {
                    worker.ReportProgress(percent, userState);
                }
                return interrupted;
            }
            public static bool CancelOperationOrReportUI(int percent)
            {
                return CancelOperationOrReportUI(percent, null);
            }

            public static bool IsCancelled
            {
                get
                {
                    bool retValue = false;
                    if (worker.CancellationPending)
                    {
                        retValue = true;                     
                    }

                    eventArgs.Cancel = retValue;

                    return retValue;
                }
            }

            public System.Boolean CheckCase
            {
                get
                {
                    return this.checkCase;
                }
                set
                {
                    this.checkCase = value;
                }
            }
            public System.Boolean CheckHidden
            {
                get
                {
                    return this.checkHidden;
                }
                set
                {
                    this.checkHidden = value;
                }
            }
            public System.Boolean CheckWholeWord
            {
                get
                {
                    return this.checkWholeWord;
                }
                set
                {
                    this.checkWholeWord = value;
                }
            }
            public System.Boolean CheckTabs
            {
                get
                {
                    return this.checkTabs;
                }
                set
                {
                    this.checkTabs = value;
                }
            }
            public System.Boolean CheckWindows
            {
                get
                {
                    return this.checkWindows;
                }
                set
                {
                    this.checkWindows = value;
                }
            }

            public System.String Term
            {
                get
                {
                    return this.targetTerm;
                }
                set
                {
                    this.targetTerm = value;
                }
            }

            public int Line
            {
                get
                {
                    return this._line;
                }
                set
                {
                    this._line = value;
                }
            }

            public int Position
            {
                get
                {
                    return this._position;
                }
                set
                {
                    this._position = value;
                }
            }

            public bool NeedToShowTheForm
            {
                get
                {
                    return this.needToShowTheForm;
                }
                set
                {
                    this.needToShowTheForm = value;
                }
            }

            public System.Boolean IsHighlighted
            {
                get
                {
                    return this.isHighlighted;
                }
            }        

            private void IEAdvancedSearch_OnSendMessage(AddinExpress.IE.ADXIESendMessageEventArgs e)
            {
                if (e.Message == Const.WM_CLOSE_FORMS)
                {
                    if (form != null && form.Visible)
                        form.Hide();
                }
                if (e.Message == Const.WM_SHOW_HTML_FORM)
                {
                    if (e.WParam == this.ParentHandle)
                    {
                        if (!IsWindowVisible(this.ParentHandle))
                        {
                            this.needToShowTheForm = true;
                            TabActivate();
                        }
                        else
                        {
                            ShowForm();
                        }
                    }
                }
            }

            public void ShowForm()
            {
                form = new HTMLForm();
                form.Text = HTMLDocument.title;                

                mshtml.IHTMLElement element = HTMLDocument.documentElement;
                form.richHtmlText.Text = element.outerHTML;
                Marshal.ReleaseComObject(element);

                int firstCharIndex = form.richHtmlText.GetFirstCharIndexFromLine(_line);
                form.richHtmlText.Select(firstCharIndex + _position, this.targetTerm.Length);
                form.richHtmlText.ScrollToCaret();

                form.ShowDialog(this);
                SetForegroundWindow(this.MainWindowHandle);
            }

            private void IEAdvancedSearch_OnTabChanged(object sender, bool success)
            {                
                if (this.needToShowTheForm)
                {
                    this.needToShowTheForm = false;
                    ShowForm();
                }
            }

            private void adxieMenuItem1_OnClick(object sender, object eventObject)
            {
                MessageBox.Show(this.HTMLDocument.ToString());
            }
        }
    }
}

