Imports System
Imports System.Runtime.InteropServices
Imports System.ComponentModel
Imports System.Windows.Forms
Imports IE = SHDocVw
Imports AddinExpress.IE
Imports System.Collections.Generic
Imports System.Collections
Imports System.Reflection

Namespace AdvancedSearch

    'Add-in Express .NET for Internet Explorer Bar
    <ComVisible(True), GuidAttribute("8A13AE90-681B-40F9-8470-CF7C588BC0EF")> _
    Public Class AdvancedSearchIEBar
        Inherits ADXIEBar

        Public Shared BHOStarted As Boolean = False

        Private WithEvents btnHighlight As System.Windows.Forms.Button
        Private WithEvents treeResult As System.Windows.Forms.TreeView
        Private WithEvents tableLayoutPanel7 As System.Windows.Forms.TableLayoutPanel
        Private WithEvents tabResults As System.Windows.Forms.TabPage
        Friend WithEvents checkWindows As System.Windows.Forms.CheckBox
        Friend WithEvents checkHidden As System.Windows.Forms.CheckBox
        Friend WithEvents checkTabs As System.Windows.Forms.CheckBox
        Private WithEvents groupBox2 As System.Windows.Forms.GroupBox
        Friend WithEvents checkWholeWord As System.Windows.Forms.CheckBox
        Friend WithEvents checkCase As System.Windows.Forms.CheckBox
        Private WithEvents groupBox3 As System.Windows.Forms.GroupBox
        Private WithEvents groupBox1 As System.Windows.Forms.GroupBox
        Private WithEvents btnSettings As System.Windows.Forms.Button
        Private WithEvents progressSearchBar As System.Windows.Forms.ProgressBar
        Private WithEvents tableLayoutPanel5 As System.Windows.Forms.TableLayoutPanel
        Private WithEvents tableLayoutPanel4 As System.Windows.Forms.TableLayoutPanel
        Private WithEvents tabOptions As System.Windows.Forms.TabPage
        Private WithEvents tabOptionsAndResults As System.Windows.Forms.TabControl
        Private WithEvents linkToSite As System.Windows.Forms.LinkLabel
        Private WithEvents tableLayoutPanel3 As System.Windows.Forms.TableLayoutPanel
        Private WithEvents btnCancel As System.Windows.Forms.Button
        Private WithEvents btnFind As System.Windows.Forms.Button
        Private WithEvents tableLayoutPanel2 As System.Windows.Forms.TableLayoutPanel
        Friend WithEvents txtTerm As System.Windows.Forms.TextBox
        Private WithEvents lblCaption As System.Windows.Forms.Label
        Private WithEvents tableLayoutPanel1 As System.Windows.Forms.TableLayoutPanel

        Private Delegate Sub SetProgressDelegate(ByVal e As ProgressChangedEventArgs)
        Private Delegate Sub EnableControlsDelegate(ByVal enable As Boolean)
        Private Delegate Sub ShowResultsDelegate(ByVal node As TreeNode)
        Private firstStart As Boolean = False
        Private _setProgress As SetProgressDelegate
        Private _enableControls As EnableControlsDelegate
        Private _showResults As ShowResultsDelegate
        Private WithEvents backgroundSearch As System.ComponentModel.BackgroundWorker

        Dim WithEvents _progressForm As ProgressForm
        Friend WithEvents ToolTip1 As System.Windows.Forms.ToolTip

        Private SearchData As SearchDescriptor


        <DllImport("user32.dll")> _
        Shared Function IsWindowVisible(ByVal hWnd As IntPtr) As Boolean

        End Function

#Region " Component Designer generated code. "
        'Required by designer
        Private components As System.ComponentModel.IContainer

        'Required by designer - do not modify
        'the following method
        Private Sub InitializeComponent()
            Me.components = New System.ComponentModel.Container
            Me.tableLayoutPanel1 = New System.Windows.Forms.TableLayoutPanel
            Me.lblCaption = New System.Windows.Forms.Label
            Me.txtTerm = New System.Windows.Forms.TextBox
            Me.tableLayoutPanel2 = New System.Windows.Forms.TableLayoutPanel
            Me.btnFind = New System.Windows.Forms.Button
            Me.btnCancel = New System.Windows.Forms.Button
            Me.tableLayoutPanel3 = New System.Windows.Forms.TableLayoutPanel
            Me.linkToSite = New System.Windows.Forms.LinkLabel
            Me.tabOptionsAndResults = New System.Windows.Forms.TabControl
            Me.tabOptions = New System.Windows.Forms.TabPage
            Me.tableLayoutPanel4 = New System.Windows.Forms.TableLayoutPanel
            Me.groupBox1 = New System.Windows.Forms.GroupBox
            Me.groupBox3 = New System.Windows.Forms.GroupBox
            Me.checkCase = New System.Windows.Forms.CheckBox
            Me.checkWholeWord = New System.Windows.Forms.CheckBox
            Me.groupBox2 = New System.Windows.Forms.GroupBox
            Me.checkTabs = New System.Windows.Forms.CheckBox
            Me.checkHidden = New System.Windows.Forms.CheckBox
            Me.checkWindows = New System.Windows.Forms.CheckBox
            Me.tableLayoutPanel5 = New System.Windows.Forms.TableLayoutPanel
            Me.progressSearchBar = New System.Windows.Forms.ProgressBar
            Me.btnSettings = New System.Windows.Forms.Button
            Me.tabResults = New System.Windows.Forms.TabPage
            Me.tableLayoutPanel7 = New System.Windows.Forms.TableLayoutPanel
            Me.btnHighlight = New System.Windows.Forms.Button
            Me.treeResult = New System.Windows.Forms.TreeView
            Me.backgroundSearch = New System.ComponentModel.BackgroundWorker
            Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
            Me.tableLayoutPanel1.SuspendLayout()
            Me.tableLayoutPanel2.SuspendLayout()
            Me.tableLayoutPanel3.SuspendLayout()
            Me.tabOptionsAndResults.SuspendLayout()
            Me.tabOptions.SuspendLayout()
            Me.tableLayoutPanel4.SuspendLayout()
            Me.groupBox1.SuspendLayout()
            Me.groupBox3.SuspendLayout()
            Me.groupBox2.SuspendLayout()
            Me.tableLayoutPanel5.SuspendLayout()
            Me.tabResults.SuspendLayout()
            Me.tableLayoutPanel7.SuspendLayout()
            Me.SuspendLayout()
            '
            'tableLayoutPanel1
            '
            Me.tableLayoutPanel1.ColumnCount = 1
            Me.tableLayoutPanel1.ColumnStyles.Add(New System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 100.0!))
            Me.tableLayoutPanel1.Controls.Add(Me.lblCaption, 0, 0)
            Me.tableLayoutPanel1.Controls.Add(Me.txtTerm, 0, 1)
            Me.tableLayoutPanel1.Controls.Add(Me.tableLayoutPanel2, 0, 2)
            Me.tableLayoutPanel1.Controls.Add(Me.tableLayoutPanel3, 0, 4)
            Me.tableLayoutPanel1.Dock = System.Windows.Forms.DockStyle.Fill
            Me.tableLayoutPanel1.Location = New System.Drawing.Point(0, 0)
            Me.tableLayoutPanel1.Name = "tableLayoutPanel1"
            Me.tableLayoutPanel1.RowCount = 5
            Me.tableLayoutPanel1.RowStyles.Add(New System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20.0!))
            Me.tableLayoutPanel1.RowStyles.Add(New System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 25.0!))
            Me.tableLayoutPanel1.RowStyles.Add(New System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 35.0!))
            Me.tableLayoutPanel1.RowStyles.Add(New System.Windows.Forms.RowStyle)
            Me.tableLayoutPanel1.RowStyles.Add(New System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 146.0!))
            Me.tableLayoutPanel1.Size = New System.Drawing.Size(217, 511)
            Me.tableLayoutPanel1.TabIndex = 1
            '
            'lblCaption
            '
            Me.lblCaption.Dock = System.Windows.Forms.DockStyle.Fill
            Me.lblCaption.Location = New System.Drawing.Point(3, 0)
            Me.lblCaption.Name = "lblCaption"
            Me.lblCaption.Size = New System.Drawing.Size(211, 20)
            Me.lblCaption.TabIndex = 0
            Me.lblCaption.Text = "Please enter a text to find:"
            Me.lblCaption.TextAlign = System.Drawing.ContentAlignment.BottomLeft
            '
            'txtTerm
            '
            Me.txtTerm.Dock = System.Windows.Forms.DockStyle.Fill
            Me.txtTerm.Location = New System.Drawing.Point(3, 23)
            Me.txtTerm.Name = "txtTerm"
            Me.txtTerm.Size = New System.Drawing.Size(211, 20)
            Me.txtTerm.TabIndex = 0
            '
            'tableLayoutPanel2
            '
            Me.tableLayoutPanel2.ColumnCount = 2
            Me.tableLayoutPanel2.ColumnStyles.Add(New System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50.0!))
            Me.tableLayoutPanel2.ColumnStyles.Add(New System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50.0!))
            Me.tableLayoutPanel2.Controls.Add(Me.btnFind, 0, 0)
            Me.tableLayoutPanel2.Controls.Add(Me.btnCancel, 1, 0)
            Me.tableLayoutPanel2.Dock = System.Windows.Forms.DockStyle.Fill
            Me.tableLayoutPanel2.Location = New System.Drawing.Point(3, 48)
            Me.tableLayoutPanel2.Name = "tableLayoutPanel2"
            Me.tableLayoutPanel2.RowCount = 1
            Me.tableLayoutPanel2.RowStyles.Add(New System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 100.0!))
            Me.tableLayoutPanel2.Size = New System.Drawing.Size(211, 29)
            Me.tableLayoutPanel2.TabIndex = 3
            '
            'btnFind
            '
            Me.btnFind.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                        Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.btnFind.Location = New System.Drawing.Point(3, 3)
            Me.btnFind.Name = "btnFind"
            Me.btnFind.Size = New System.Drawing.Size(99, 23)
            Me.btnFind.TabIndex = 2
            Me.btnFind.Text = "Find"
            Me.btnFind.UseVisualStyleBackColor = True
            '
            'btnCancel
            '
            Me.btnCancel.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                        Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.btnCancel.Enabled = False
            Me.btnCancel.Location = New System.Drawing.Point(108, 3)
            Me.btnCancel.Name = "btnCancel"
            Me.btnCancel.Size = New System.Drawing.Size(100, 23)
            Me.btnCancel.TabIndex = 3
            Me.btnCancel.Text = "Cancel"
            Me.btnCancel.UseVisualStyleBackColor = True
            '
            'tableLayoutPanel3
            '
            Me.tableLayoutPanel3.ColumnCount = 1
            Me.tableLayoutPanel3.ColumnStyles.Add(New System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 100.0!))
            Me.tableLayoutPanel3.Controls.Add(Me.linkToSite, 0, 1)
            Me.tableLayoutPanel3.Controls.Add(Me.tabOptionsAndResults, 0, 0)
            Me.tableLayoutPanel3.Dock = System.Windows.Forms.DockStyle.Fill
            Me.tableLayoutPanel3.Location = New System.Drawing.Point(3, 83)
            Me.tableLayoutPanel3.Name = "tableLayoutPanel3"
            Me.tableLayoutPanel3.RowCount = 2
            Me.tableLayoutPanel3.RowStyles.Add(New System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 100.0!))
            Me.tableLayoutPanel3.RowStyles.Add(New System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20.0!))
            Me.tableLayoutPanel3.RowStyles.Add(New System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20.0!))
            Me.tableLayoutPanel3.Size = New System.Drawing.Size(211, 425)
            Me.tableLayoutPanel3.TabIndex = 4
            '
            'linkToSite
            '
            Me.linkToSite.AutoSize = True
            Me.linkToSite.Cursor = System.Windows.Forms.Cursors.Hand
            Me.linkToSite.Dock = System.Windows.Forms.DockStyle.Fill
            Me.linkToSite.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
            Me.linkToSite.Location = New System.Drawing.Point(3, 405)
            Me.linkToSite.Name = "linkToSite"
            Me.linkToSite.Size = New System.Drawing.Size(205, 20)
            Me.linkToSite.TabIndex = 10
            Me.linkToSite.TabStop = True
            Me.linkToSite.Text = "Add-in Express Ltd."
            Me.linkToSite.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
            '
            'tabOptionsAndResults
            '
            Me.tabOptionsAndResults.Controls.Add(Me.tabOptions)
            Me.tabOptionsAndResults.Controls.Add(Me.tabResults)
            Me.tabOptionsAndResults.Dock = System.Windows.Forms.DockStyle.Fill
            Me.tabOptionsAndResults.Location = New System.Drawing.Point(3, 3)
            Me.tabOptionsAndResults.Name = "tabOptionsAndResults"
            Me.tabOptionsAndResults.SelectedIndex = 0
            Me.tabOptionsAndResults.Size = New System.Drawing.Size(205, 399)
            Me.tabOptionsAndResults.TabIndex = 9
            '
            'tabOptions
            '
            Me.tabOptions.Controls.Add(Me.tableLayoutPanel4)
            Me.tabOptions.Location = New System.Drawing.Point(4, 22)
            Me.tabOptions.Name = "tabOptions"
            Me.tabOptions.Padding = New System.Windows.Forms.Padding(3)
            Me.tabOptions.Size = New System.Drawing.Size(197, 373)
            Me.tabOptions.TabIndex = 0
            Me.tabOptions.Text = "Options"
            Me.tabOptions.UseVisualStyleBackColor = True
            '
            'tableLayoutPanel4
            '
            Me.tableLayoutPanel4.ColumnCount = 1
            Me.tableLayoutPanel4.ColumnStyles.Add(New System.Windows.Forms.ColumnStyle)
            Me.tableLayoutPanel4.Controls.Add(Me.groupBox1, 0, 0)
            Me.tableLayoutPanel4.Controls.Add(Me.tableLayoutPanel5, 0, 1)
            Me.tableLayoutPanel4.Dock = System.Windows.Forms.DockStyle.Fill
            Me.tableLayoutPanel4.Location = New System.Drawing.Point(3, 3)
            Me.tableLayoutPanel4.Name = "tableLayoutPanel4"
            Me.tableLayoutPanel4.RowCount = 2
            Me.tableLayoutPanel4.RowStyles.Add(New System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 180.0!))
            Me.tableLayoutPanel4.RowStyles.Add(New System.Windows.Forms.RowStyle)
            Me.tableLayoutPanel4.RowStyles.Add(New System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20.0!))
            Me.tableLayoutPanel4.Size = New System.Drawing.Size(191, 367)
            Me.tableLayoutPanel4.TabIndex = 0
            '
            'groupBox1
            '
            Me.groupBox1.Controls.Add(Me.groupBox3)
            Me.groupBox1.Controls.Add(Me.groupBox2)
            Me.groupBox1.Dock = System.Windows.Forms.DockStyle.Fill
            Me.groupBox1.Location = New System.Drawing.Point(3, 3)
            Me.groupBox1.Name = "groupBox1"
            Me.groupBox1.Size = New System.Drawing.Size(185, 174)
            Me.groupBox1.TabIndex = 22
            Me.groupBox1.TabStop = False
            '
            'groupBox3
            '
            Me.groupBox3.Controls.Add(Me.checkCase)
            Me.groupBox3.Controls.Add(Me.checkWholeWord)
            Me.groupBox3.Location = New System.Drawing.Point(3, 12)
            Me.groupBox3.Name = "groupBox3"
            Me.groupBox3.Size = New System.Drawing.Size(175, 64)
            Me.groupBox3.TabIndex = 30
            Me.groupBox3.TabStop = False
            Me.groupBox3.Text = "Search options"
            '
            'checkCase
            '
            Me.checkCase.AutoSize = True
            Me.checkCase.Location = New System.Drawing.Point(6, 42)
            Me.checkCase.Name = "checkCase"
            Me.checkCase.Size = New System.Drawing.Size(82, 17)
            Me.checkCase.TabIndex = 22
            Me.checkCase.Text = "Match case"
            Me.checkCase.UseVisualStyleBackColor = True
            '
            'checkWholeWord
            '
            Me.checkWholeWord.AutoSize = True
            Me.checkWholeWord.Location = New System.Drawing.Point(6, 19)
            Me.checkWholeWord.Name = "checkWholeWord"
            Me.checkWholeWord.Size = New System.Drawing.Size(135, 17)
            Me.checkWholeWord.TabIndex = 21
            Me.checkWholeWord.Text = "Match whole word only"
            Me.checkWholeWord.UseVisualStyleBackColor = True
            '
            'groupBox2
            '
            Me.groupBox2.Controls.Add(Me.checkTabs)
            Me.groupBox2.Controls.Add(Me.checkHidden)
            Me.groupBox2.Controls.Add(Me.checkWindows)
            Me.groupBox2.Location = New System.Drawing.Point(6, 82)
            Me.groupBox2.Name = "groupBox2"
            Me.groupBox2.Size = New System.Drawing.Size(172, 86)
            Me.groupBox2.TabIndex = 29
            Me.groupBox2.TabStop = False
            Me.groupBox2.Text = "Look in"
            '
            'checkTabs
            '
            Me.checkTabs.AutoSize = True
            Me.checkTabs.Enabled = False
            Me.checkTabs.Location = New System.Drawing.Point(6, 62)
            Me.checkTabs.Name = "checkTabs"
            Me.checkTabs.Size = New System.Drawing.Size(60, 17)
            Me.checkTabs.TabIndex = 19
            Me.checkTabs.Text = "All tabs"
            Me.ToolTip1.SetToolTip(Me.checkTabs, "Available when 'Quick Tabs' is enabled.")
            Me.checkTabs.UseVisualStyleBackColor = True
            '
            'checkHidden
            '
            Me.checkHidden.AutoSize = True
            Me.checkHidden.Location = New System.Drawing.Point(6, 16)
            Me.checkHidden.Name = "checkHidden"
            Me.checkHidden.Size = New System.Drawing.Size(99, 17)
            Me.checkHidden.TabIndex = 23
            Me.checkHidden.Text = "Hidden content"
            Me.checkHidden.UseVisualStyleBackColor = True
            '
            'checkWindows
            '
            Me.checkWindows.AutoSize = True
            Me.checkWindows.Location = New System.Drawing.Point(6, 39)
            Me.checkWindows.Name = "checkWindows"
            Me.checkWindows.Size = New System.Drawing.Size(81, 17)
            Me.checkWindows.TabIndex = 20
            Me.checkWindows.Text = "All windows"
            Me.ToolTip1.SetToolTip(Me.checkWindows, "Available when 'Quick Tabs' is enabled.")
            Me.checkWindows.UseVisualStyleBackColor = True
            '
            'tableLayoutPanel5
            '
            Me.tableLayoutPanel5.ColumnCount = 1
            Me.tableLayoutPanel5.ColumnStyles.Add(New System.Windows.Forms.ColumnStyle)
            Me.tableLayoutPanel5.Controls.Add(Me.progressSearchBar, 0, 1)
            Me.tableLayoutPanel5.Controls.Add(Me.btnSettings, 0, 0)
            Me.tableLayoutPanel5.Dock = System.Windows.Forms.DockStyle.Fill
            Me.tableLayoutPanel5.Location = New System.Drawing.Point(3, 183)
            Me.tableLayoutPanel5.Name = "tableLayoutPanel5"
            Me.tableLayoutPanel5.RowCount = 3
            Me.tableLayoutPanel5.RowStyles.Add(New System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 30.0!))
            Me.tableLayoutPanel5.RowStyles.Add(New System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 30.0!))
            Me.tableLayoutPanel5.RowStyles.Add(New System.Windows.Forms.RowStyle)
            Me.tableLayoutPanel5.RowStyles.Add(New System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20.0!))
            Me.tableLayoutPanel5.RowStyles.Add(New System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20.0!))
            Me.tableLayoutPanel5.Size = New System.Drawing.Size(185, 181)
            Me.tableLayoutPanel5.TabIndex = 21
            '
            'progressSearchBar
            '
            Me.progressSearchBar.Dock = System.Windows.Forms.DockStyle.Fill
            Me.progressSearchBar.Location = New System.Drawing.Point(3, 33)
            Me.progressSearchBar.MarqueeAnimationSpeed = 0
            Me.progressSearchBar.Name = "progressSearchBar"
            Me.progressSearchBar.Size = New System.Drawing.Size(179, 24)
            Me.progressSearchBar.Style = System.Windows.Forms.ProgressBarStyle.Continuous
            Me.progressSearchBar.TabIndex = 21
            Me.progressSearchBar.Visible = False
            '
            'btnSettings
            '
            Me.btnSettings.Dock = System.Windows.Forms.DockStyle.Fill
            Me.btnSettings.Location = New System.Drawing.Point(3, 3)
            Me.btnSettings.Name = "btnSettings"
            Me.btnSettings.Size = New System.Drawing.Size(179, 24)
            Me.btnSettings.TabIndex = 22
            Me.btnSettings.Text = "Settings"
            Me.btnSettings.UseVisualStyleBackColor = True
            '
            'tabResults
            '
            Me.tabResults.Controls.Add(Me.tableLayoutPanel7)
            Me.tabResults.Location = New System.Drawing.Point(4, 22)
            Me.tabResults.Name = "tabResults"
            Me.tabResults.Padding = New System.Windows.Forms.Padding(3)
            Me.tabResults.Size = New System.Drawing.Size(197, 373)
            Me.tabResults.TabIndex = 1
            Me.tabResults.Text = "Results"
            Me.tabResults.UseVisualStyleBackColor = True
            '
            'tableLayoutPanel7
            '
            Me.tableLayoutPanel7.ColumnCount = 1
            Me.tableLayoutPanel7.ColumnStyles.Add(New System.Windows.Forms.ColumnStyle)
            Me.tableLayoutPanel7.Controls.Add(Me.btnHighlight, 0, 1)
            Me.tableLayoutPanel7.Controls.Add(Me.treeResult, 0, 0)
            Me.tableLayoutPanel7.Dock = System.Windows.Forms.DockStyle.Fill
            Me.tableLayoutPanel7.Location = New System.Drawing.Point(3, 3)
            Me.tableLayoutPanel7.Name = "tableLayoutPanel7"
            Me.tableLayoutPanel7.RowCount = 2
            Me.tableLayoutPanel7.RowStyles.Add(New System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 100.0!))
            Me.tableLayoutPanel7.RowStyles.Add(New System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 30.0!))
            Me.tableLayoutPanel7.Size = New System.Drawing.Size(191, 367)
            Me.tableLayoutPanel7.TabIndex = 0
            '
            'btnHighlight
            '
            Me.btnHighlight.Enabled = False
            Me.btnHighlight.Location = New System.Drawing.Point(3, 340)
            Me.btnHighlight.Name = "btnHighlight"
            Me.btnHighlight.Size = New System.Drawing.Size(184, 24)
            Me.btnHighlight.TabIndex = 22
            Me.btnHighlight.Text = "Highlight"
            Me.btnHighlight.UseVisualStyleBackColor = True
            '
            'treeResult
            '
            Me.treeResult.BackColor = System.Drawing.SystemColors.Window
            Me.treeResult.BorderStyle = System.Windows.Forms.BorderStyle.None
            Me.treeResult.Cursor = System.Windows.Forms.Cursors.Hand
            Me.treeResult.Dock = System.Windows.Forms.DockStyle.Fill
            Me.treeResult.Location = New System.Drawing.Point(3, 3)
            Me.treeResult.Name = "treeResult"
            Me.treeResult.Size = New System.Drawing.Size(185, 331)
            Me.treeResult.TabIndex = 2
            '
            'backgroundSearch
            '
            Me.backgroundSearch.WorkerReportsProgress = True
            Me.backgroundSearch.WorkerSupportsCancellation = True
            '
            'AdvancedSearchIEBar
            '
            Me.AutoScaleDimensions = New System.Drawing.SizeF(96.0!, 96.0!)
            Me.Controls.Add(Me.tableLayoutPanel1)
            Me.MinimumSize = New System.Drawing.Size(205, 511)
            Me.Name = "AdvancedSearchIEBar"
            Me.Size = New System.Drawing.Size(217, 511)
            Me.tableLayoutPanel1.ResumeLayout(False)
            Me.tableLayoutPanel1.PerformLayout()
            Me.tableLayoutPanel2.ResumeLayout(False)
            Me.tableLayoutPanel3.ResumeLayout(False)
            Me.tableLayoutPanel3.PerformLayout()
            Me.tabOptionsAndResults.ResumeLayout(False)
            Me.tabOptions.ResumeLayout(False)
            Me.tableLayoutPanel4.ResumeLayout(False)
            Me.groupBox1.ResumeLayout(False)
            Me.groupBox3.ResumeLayout(False)
            Me.groupBox3.PerformLayout()
            Me.groupBox2.ResumeLayout(False)
            Me.groupBox2.PerformLayout()
            Me.tableLayoutPanel5.ResumeLayout(False)
            Me.tabResults.ResumeLayout(False)
            Me.tableLayoutPanel7.ResumeLayout(False)
            Me.ResumeLayout(False)

        End Sub

#End Region

#Region " Add-in Express automatic code "

        'Required by Add-in Express - do not modify
        'the methods within me region

        Public Overrides Function GetContainer() As System.ComponentModel.IContainer
            If components Is Nothing Then
                components = New System.ComponentModel.Container
            End If
            GetContainer = components
        End Function

#End Region

        Public Sub New()
            MyBase.New()
            'This call is required by the Component Designer
            InitializeComponent()
        End Sub

        Public Sub New(ByVal mode As Integer)
            MyBase.New(mode)
            'This call is required by the Component Designer
            InitializeComponent()
        End Sub

        Public ReadOnly Property IEApp() As IE.WebBrowser
            Get
                Return CType(Me.IEObj, IE.WebBrowser)
            End Get
        End Property

        Public ReadOnly Property HTMLDocument() As mshtml.HTMLDocument
            Get
                Return CType(Me.HTMLDocumentObj, mshtml.HTMLDocument)
            End Get
        End Property

        Public ReadOnly Property CurrentModule() As IEModule
            Get
                Return Me.Module
            End Get
        End Property

        Private Sub InitializeAdvancedSearch()
            _setProgress = New SetProgressDelegate(AddressOf SetProgressValue)
            _enableControls = New EnableControlsDelegate(AddressOf EnableControls)
            _showResults = New ShowResultsDelegate(AddressOf ShowSearchResult)
        End Sub

        Private Sub SetProgressValue(ByVal e As ProgressChangedEventArgs)
            If Not (e.ProgressPercentage = Constant.None) Then
                progressSearchBar.Increment(e.ProgressPercentage - progressSearchBar.Value)
            End If
        End Sub

        Private Sub EnableControls(ByVal enabled As Boolean)
            checkCase.Enabled = enabled
            checkHidden.Enabled = enabled
            checkWholeWord.Enabled = enabled
            checkWindows.Enabled = enabled
            btnFind.Enabled = enabled
            btnCancel.Enabled = Not enabled
            txtTerm.Enabled = enabled
            If (enabled) Then
                progressSearchBar.Visible = False
                progressSearchBar.Value = 0
            Else
                progressSearchBar.Visible = True
                tabOptionsAndResults.SelectTab(tabOptions)
            End If
            If (treeResult.Nodes.Count > 0) Then
                btnHighlight.Enabled = True
            Else
                btnHighlight.Enabled = False
            End If
            checkTabs.Enabled = ((IEVersion > 6) And enabled)
        End Sub

        Private Sub ShowSearchResult(ByVal resultNode As TreeNode)
            For Each node As TreeNode In resultNode.Nodes
                treeResult.Nodes.Add(node)
            Next
            treeResult.ExpandAll()
            treeResult.SelectedNode = treeResult.Nodes(0)
            tabOptionsAndResults.SelectTab(tabResults)
        End Sub

        Private Function CreateHTMLDoc(ByVal htmlText As String) As mshtml.HTMLDocument

            Dim cloneDoc As mshtml.HTMLDocument = Nothing

            cloneDoc = New mshtml.HTMLDocument()
            cloneDoc.open("text/html", "replace", Nothing, Nothing)
            GetType(mshtml.HTMLDocument).InvokeMember("write", BindingFlags.InvokeMethod, Nothing, cloneDoc, New Object() {htmlText})

            Return cloneDoc
        End Function

        Private Sub btnFind_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnFind.Click
            If Not (txtTerm.Text.Trim() = String.Empty) Then
                treeResult.Nodes.Clear()
                EnableControls(False)
                SendMessageToAll(Constant.WM_CLOSE_FORMS, IntPtr.Zero, IntPtr.Zero)

                progressSearchBar.Visible = True

                SearchData = New SearchDescriptor()
                SearchData.CheckCase = checkCase.Checked
                SearchData.CheckHidden = checkHidden.Checked
                SearchData.CheckTabs = checkTabs.Checked
                SearchData.CheckWholeWord = checkWholeWord.Checked
                SearchData.CheckWindows = checkWindows.Checked
                SearchData.Term = txtTerm.Text

                If (SearchData.Modules Is Nothing) Then
                    SearchData.Modules = New List(Of ModuleDescriptor)
                End If

                SearchData.Modules.Clear()

                If (checkWindows.Checked) Then
                    Dim m As IEModule = Nothing

                    Dim modules As ArrayList = ADXIEModule.GetModulesByTypeName(GetType(IEModule).FullName)

                    For i As Integer = 0 To modules.Count - 1
                        m = modules(i)
                        If (checkTabs.Checked) Then

                            Dim moduleDesc As ModuleDescriptor = New ModuleDescriptor()
                            moduleDesc.HTMLDoc = CreateHTMLDoc(m.GetHTMLText())
                            moduleDesc.MainWnd = m.MainWindowHandle
                            moduleDesc.NativeWnd = m.NativeWindowHandle
                            moduleDesc.TabWnd = m.ParentHandle
                            moduleDesc.ThreadId = m.ThreadID
                            SearchData.Modules.Add(moduleDesc)

                            If ((m.ThreadID = Me.CurrentModule.ThreadID) And (m.MainWindowHandle.ToInt64() = Me.CurrentModule.MainWindowHandle.ToInt64())) Then
                                SearchData.SearchModuleIndex = SearchData.Modules.Count - 1
                            End If
                        Else
                            If (IsWindowVisible(m.ParentHandle)) Then
                                Dim moduleDesc As ModuleDescriptor = New ModuleDescriptor()

                                moduleDesc.HTMLDoc = CreateHTMLDoc(m.GetHTMLText())
                                moduleDesc.MainWnd = m.MainWindowHandle
                                moduleDesc.NativeWnd = m.NativeWindowHandle
                                moduleDesc.TabWnd = m.ParentHandle
                                moduleDesc.ThreadId = m.ThreadID
                                SearchData.Modules.Add(moduleDesc)

                                If ((m.ThreadID = Me.CurrentModule.ThreadID) And (m.MainWindowHandle.ToInt64() = Me.CurrentModule.MainWindowHandle.ToInt64())) Then
                                    SearchData.SearchModuleIndex = SearchData.Modules.Count - 1
                                End If
                            End If
                        End If
                    Next
                ElseIf (checkTabs.Checked) Then
                    Dim m As IEModule = Nothing

                    For i As Integer = 0 To Me.Module.GetModuleCount() - 1
                        m = Me.Module.GetModuleByIndex(i)

                        If (m.MainWindowHandle = CurrentModule.MainWindowHandle) Then
                            Dim moduleDesc As ModuleDescriptor = New ModuleDescriptor()
                            moduleDesc.HTMLDoc = CreateHTMLDoc(m.GetHTMLText())
                            moduleDesc.MainWnd = m.MainWindowHandle
                            moduleDesc.NativeWnd = m.NativeWindowHandle
                            moduleDesc.TabWnd = m.ParentHandle
                            moduleDesc.ThreadId = m.ThreadID
                            SearchData.Modules.Add(moduleDesc)
                            If (m.ThreadID = Me.CurrentModule.ThreadID) Then
                                SearchData.SearchModuleIndex = SearchData.Modules.Count - 1
                            End If
                        End If
                    Next
                Else
                    Dim moduleDesc As ModuleDescriptor = New ModuleDescriptor()
                    moduleDesc.HTMLDoc = CreateHTMLDoc(Me.CurrentModule.GetHTMLText())
                    moduleDesc.MainWnd = Me.CurrentModule.MainWindowHandle
                    moduleDesc.NativeWnd = Me.CurrentModule.NativeWindowHandle
                    moduleDesc.TabWnd = Me.CurrentModule.ParentHandle
                    moduleDesc.ThreadId = Me.CurrentModule.ThreadID
                    SearchData.Modules.Add(moduleDesc)
                    SearchData.SearchModuleIndex = 0
                End If

                backgroundSearch.RunWorkerAsync(SearchData)
            End If
        End Sub

        Private Sub treeResult_NodeMouseDoubleClick(ByVal sender As Object, ByVal e As TreeNodeMouseClickEventArgs) Handles treeResult.NodeMouseDoubleClick
            If (e.Node.Level = 0) Then Return
            CurrentModule.Navigate(e.Node)
        End Sub

        Private Sub txtTerm_KeyDown(ByVal sender As Object, ByVal e As KeyEventArgs) Handles txtTerm.KeyDown
            If (e.KeyCode = Keys.Enter) Then
                btnFind_Click(Me, EventArgs.Empty)
            End If
        End Sub

        Private Sub AdvancedSearchIEBar_OnBeforeDestroy(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.OnBeforeDestroy
            Dim ptrThread As IntPtr = New IntPtr(Me.Module.ThreadID)
            Me.SendMessageToAll(Constant.WM_ITEM_CLOSED, ptrThread, IntPtr.Zero)
        End Sub

        Private Sub AdvancedSearchIEBar_OnSendMessage(ByVal e As ADXIESendMessageEventArgs) Handles MyBase.OnSendMessage
            If Not (CurrentModule Is Nothing) Then
                If (e.Message = Constant.WM_ITEM_CLOSED) Then
                    Dim threadID As Integer = e.WParam.ToInt32()
                    CurrentModule.RefreshTree(treeResult, threadID)
                End If
            End If
        End Sub

        Private Sub backgroundSearch_DoWork(ByVal sender As Object, ByVal e As DoWorkEventArgs) Handles backgroundSearch.DoWork
            Try
                IEModule.Find(CType(sender, BackgroundWorker), e)
            Catch ex As Exception
                System.Windows.Forms.MessageBox.Show(New WindowHandle(Me.MainWindowHandle), "An unexpected error occured in the code of add-on.\n\rFor more information please try debugging the add-on.", _
                   "Advanced Search sample add-in for IE", MessageBoxButtons.OK, MessageBoxIcon.Information)
            End Try

        End Sub

        Private Sub backgroundSearch_ProgressChanged(ByVal sender As Object, ByVal e As ProgressChangedEventArgs) Handles backgroundSearch.ProgressChanged
            progressSearchBar.Invoke(_setProgress, New Object() {e})
        End Sub

        Private Sub backgroundSearch_RunWorkerCompleted(ByVal sender As Object, ByVal e As RunWorkerCompletedEventArgs) Handles backgroundSearch.RunWorkerCompleted
            If (e.Error Is Nothing) Then
                If (Not e.Cancelled) Then
                    Dim resultNode As TreeNode = CType(e.Result, SearchDescriptor).ResultNode
                    If (resultNode.Nodes.Count > Constant.Ok) Then
                        Me.Invoke(_showResults, New Object() {resultNode})
                    Else
                        System.Windows.Forms.MessageBox.Show(New WindowHandle(ParentHandle), "Text not found.", "Advanced search", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    End If
                End If
                Me.Invoke(_enableControls, New Object() {True})
            End If
        End Sub

        Private Sub btnCancel_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnCancel.Click
            backgroundSearch.CancelAsync()
        End Sub

        Private Sub linkToSite_LinkClicked(ByVal sender As Object, ByVal e As LinkLabelLinkClickedEventArgs) Handles linkToSite.LinkClicked
            Dim one As Object = 2048
            Dim two As Object = "_self"
            Dim three As Object = Nothing
            Dim four As Object = Nothing
            IEApp.Navigate("http://www.add-in-express.com", one, two, three, four)
        End Sub

        Private Sub btnHighlight_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnHighlight.Click
            _progressForm = New ProgressForm()
            _progressForm.ShowDialog(New WindowHandle(ParentHandle))
            Dim btn As Button = CType(sender, Button)
            If Not (btn Is Nothing) Then
                If (CurrentModule.IsHighlighted) Then
                    btn.Text = "Clear"
                    Me.btnSettings.Enabled = False
                Else
                    btn.Text = "Highlight"
                    Me.btnSettings.Enabled = True
                End If
            End If
        End Sub

        Private Sub AdvancedSearchIEBar_OnConnect(ByVal sender As Object, ByVal threadId As Integer) Handles MyBase.OnConnect
            InitializeAdvancedSearch()
            EnableControls(AdvancedSearchIEBar.BHOStarted)
            If AdvancedSearchIEBar.BHOStarted Then
                firstStart = True
            End If
        End Sub

        Sub progressForm_Shown(ByVal sender As Object, ByVal e As EventArgs) Handles _progressForm.Shown
            Dim root As TreeNode = New TreeNode()
            For Each node As TreeNode In treeResult.Nodes
                root.Nodes.Add(node.Clone())
            Next
            Dim form As ProgressForm = CType(sender, ProgressForm)
            CurrentModule.Highlight(form, root, SearchData)
            form.DialogResult = DialogResult.OK
        End Sub

        Private Sub btnSettings_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnSettings.Click
            CType(Me.Module, IEModule).ShowSettings()
        End Sub

        Private Sub AdvancedSearchIEBar_DownloadComplete() Handles MyBase.DownloadComplete
            If Not firstStart Then
                firstStart = True
                EnableControls(AdvancedSearchIEBar.BHOStarted)
            End If
        End Sub
    End Class
End Namespace
