Imports System
Imports System.Collections.Generic
Imports System.Text
Imports System.Runtime.InteropServices
Imports System.IO
Imports System.Runtime.Serialization.Formatters.Binary
Imports System.Drawing

Namespace AdvancedSearch
    <ComVisible(False)> _
    Public Class GlobalData
        Private Shared _instance As GlobalData
        Private Shared _path As String
        Private _settings As GlobalSettings

        Public Sub New()
            If (File.Exists(_path)) Then
                Using fStream As FileStream = New FileStream(_path, FileMode.Open, FileAccess.Read)
                    Dim bFormatter As BinaryFormatter = New BinaryFormatter()
                    _settings = bFormatter.Deserialize(fStream)
                End Using
            Else
                _settings = New GlobalSettings(SystemColors.ButtonFace, SystemColors.ControlText, False, False, False, "Ctrl+F")
            End If
        End Sub

        Shared Sub New()
            Dim remainder As String = "AdvancedSearch" + Path.DirectorySeparatorChar + System.Environment.UserName + Path.DirectorySeparatorChar + "Settings_vb.dat"
            _path = Path.Combine(System.Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData), remainder)
        End Sub

        Public Shared ReadOnly Property Instance() As GlobalData
            Get
                If (GlobalData._instance Is Nothing) Then
                    GlobalData._instance = New GlobalData()
                End If
                Return GlobalData._instance
            End Get
        End Property

        Public Sub SaveSettings()
            If (Not Directory.Exists(Path.GetDirectoryName(_path))) Then
                Directory.CreateDirectory(Path.GetDirectoryName(_path))
            End If
            Using fStream As FileStream = New FileStream(_path, FileMode.OpenOrCreate, FileAccess.Write)
                Dim bFormatter As BinaryFormatter = New BinaryFormatter()
                bFormatter.Serialize(fStream, Settings)
            End Using
        End Sub

        Public ReadOnly Property Settings() As GlobalSettings
            Get
                Return Me._settings
            End Get
        End Property
    End Class
End Namespace
