Imports System
Imports System.Runtime.InteropServices
Imports System.ComponentModel
Imports System.Windows.Forms
Imports IE = SHDocVw
Imports System.Text
Imports System.Collections
Imports System.Collections.Generic
Imports AddinExpress.IE

Namespace AdvancedSearch
    'Namespace AdvancedSearch

    'Add-in Express .NET for Internet Explorer Module
    <ComVisible(True), GuidAttribute("0336CAAC-2DD2-47EC-82CF-08B04546A44D")> _
    Public Class IEModule
        Inherits ADXIEModule

        Private WithEvents adxieKeyboardCommand As ADXIEKeyboardShortcut
        Friend WithEvents AdxieBarItem1 As ADXIEBarItem

#Region " Component Designer generated code. "
        'Required by designer
        Private components As System.ComponentModel.IContainer

        'Required by designer - do not modify
        'the following method
        Private Sub InitializeComponent()
            Me.components = New System.ComponentModel.Container
            Me.adxieKeyboardCommand = New AddinExpress.IE.ADXIEKeyboardShortcut(Me.components)
            Me.AdxieBarItem1 = New AddinExpress.IE.ADXIEBarItem(Me.components)
            '
            'adxieKeyboardCommand
            '
            Me.adxieKeyboardCommand.ShortcutText = "Ctrl+F"
            '
            'AdxieBarItem1
            '
            Me.AdxieBarItem1.BarType = "AdvancedSearch.AdvancedSearch.AdvancedSearchIEBar"
            Me.AdxieBarItem1.HelpText = "Add-in Express Advanced search engine"
            Me.AdxieBarItem1.MaxSize = 220
            Me.AdxieBarItem1.MenuText = "Advanced search (VB)"
            Me.AdxieBarItem1.MinSize = 220
            Me.AdxieBarItem1.Title = "Advanced search (VB)"
            '
            'IEModule
            '
            Me.Bars.Add(Me.AdxieBarItem1)
            Me.HandleShortcuts = True
            Me.ModuleName = "AdvancedSearchForIE"

        End Sub

#End Region

#Region " Add-in Express automatic code "

        'Required by Add-in Express - do not modify
        'the methods within me region

        Public Overrides Function GetContainer() As System.ComponentModel.IContainer
            If components Is Nothing Then
                components = New System.ComponentModel.Container
            End If
            GetContainer = components
        End Function

        <ComRegisterFunctionAttribute()> _
        Public Shared Sub RegisterIEModule(ByVal t As Type)
            ADXIEModule.RegisterIEModuleInternal(t)
        End Sub

        <ComUnregisterFunctionAttribute()> _
        Public Shared Sub UnregisterIEModule(ByVal t As Type)
            ADXIEModule.UnregisterIEModuleInternal(t)
        End Sub

        <ComVisible(True)> _
        Public Class IECustomContextMenuCommands
            Inherits ADXIEModule.ADXIEContextMenuCommandDispatcher

        End Class

        <ComVisible(True)> _
        Public Class IECustomCommands
            Inherits ADXIEModule.ADXIECommandDispatcher

        End Class

#End Region

        Public Sub New()
            MyBase.New()
            'This call is required by the Component Designer
            InitializeComponent()
        End Sub

        Public Sub New(ByVal container As IContainer)
            MyBase.New(container)
            container.Add(Me)
            'This call is required by the Component Designer
            InitializeComponent()
        End Sub

        Public ReadOnly Property IEApp() As IE.WebBrowser
            Get
                Return CType(Me.IEObj, IE.WebBrowser)
            End Get
        End Property

        Public ReadOnly Property HTMLDocument() As mshtml.HTMLDocument
            Get
                Return CType(Me.HTMLDocumentObj, mshtml.HTMLDocument)
            End Get
        End Property

        Private Sub adxieKeyboardCommand_OnAction(ByVal sender As Object) Handles adxieKeyboardCommand.OnAction
            Dim _module As IEModule = CType(ADXIEModule.CurrentInstance(Me.ThreadID), IEModule)

            If Not (_module Is Nothing) Then

                Dim moduleType As Type = Type.GetType("AdvancedSearch.AddinExpress.AdvancedSearch.AdvancedSearchIEBar", False, True)

                Dim index As Integer = Me.Bars.IndexOf(moduleType.FullName)
                If (index >= 0) Then
                    Dim item As ADXIEBarItem = CType(_module.Bars(index), ADXIEBarItem)
                    Dim g As Object = moduleType.GUID.ToString("B")
                    Dim dummy As Object = Nothing
                    If (item.BarObj Is Nothing) Then
                        Dim bShow As Object = True
                        IEApp.ShowBrowserBar(g, bShow, dummy)
                    Else
                        Dim dm As AdvancedSearchIEBar = CType(item.BarObj, AdvancedSearchIEBar)
                        If Not (dm Is Nothing) Then
                            If (Not dm.Visible) Then
                                Dim bShow As Object = True
                                IEApp.ShowBrowserBar(g, bShow, dummy)
                            Else
                                Dim bShow As Object = False
                                IEApp.ShowBrowserBar(g, bShow, dummy)
                            End If
                        End If
                    End If
                End If
            End If
        End Sub

        Private Sub IEAdvancedSearch_OnConnect(ByVal sender As Object, ByVal threadId As Integer) Handles MyBase.OnConnect
            AdvancedSearchIEBar.BHOStarted = True
            Me.adxieKeyboardCommand.ShortcutText = GlobalData.Instance.Settings.Shortcut
        End Sub

        Friend Sub ShowSettings()
            Dim setForm As AdvancedSearchSettings = New AdvancedSearchSettings(GlobalData.Instance.Settings)
            Select Case setForm.ShowDialog(New WindowHandle(ParentHandle))
                Case DialogResult.OK
                    setForm.SynchronizeSettings()
                    GlobalData.Instance.SaveSettings()
                Case DialogResult.Cancel
                    setForm.DiscardSettings()
            End Select
        End Sub

        <DllImport("user32.dll")> _
        Shared Function ShowWindow(ByVal hWnd As IntPtr, ByVal cmdState As Integer) As Boolean

        End Function
        <DllImport("user32.dll")> _
        Shared Function SetForegroundWindow(ByVal hWnd As IntPtr) As Integer

        End Function
        <DllImport("user32.dll")> _
        Shared Function IsIconic(ByVal hWnd As IntPtr) As Boolean

        End Function
        <DllImport("user32.dll")> _
        Shared Function IsWindow(ByVal hWnd As IntPtr) As Boolean

        End Function

        <DllImport("user32", CharSet:=CharSet.Auto)> _
        Shared Function GetWindowText(ByVal hWnd As IntPtr, ByVal lpString As StringBuilder, ByVal cch As Integer) As Integer

        End Function
        <DllImport("user32.dll")> _
        Shared Function IsWindowVisible(ByVal hWnd As IntPtr) As Boolean

        End Function

        Public ReadOnly Property IEBar() As AdvancedSearchIEBar
            Get
                Return Me.Bars(0).BarObj
            End Get
        End Property

        Public Shared Sub ShowFrame(ByVal hWnd As IntPtr)
            SetForegroundWindow(hWnd)
            If (IsIconic(hWnd)) Then
                ShowWindow(hWnd, 9)
            Else
                ShowWindow(hWnd, 5)
            End If
        End Sub

        Private _isHighlighted As Boolean = False

        Private _line As Integer = New Integer
        Private _position As Integer = New Integer
        Private _form As HTMLForm

        Private _checkCase As Boolean = New Boolean()
        Private _checkHidden As Boolean = New Boolean()
        Private _checkWholeWord As Boolean = New Boolean()
        Private _checkTabs As Boolean = New Boolean()
        Private _checkWindows As Boolean = New Boolean()
        Private targetTerm As String = String.Empty
        Private _flags As SearchFlags = SearchFlags.ieMatchPartialWords

        Private Shared _worker As System.ComponentModel.BackgroundWorker
        Private Shared _eventArgs As System.ComponentModel.DoWorkEventArgs

        Private _needToShowTheForm As Boolean = False

        Public Property Line() As Integer
            Get
                Return Me._line
            End Get
            Set(ByVal value As Integer)
                Me._line = value
            End Set
        End Property

        Public Property Position() As Integer
            Get
                Return Me._position
            End Get
            Set(ByVal value As Integer)
                Me._position = value
            End Set
        End Property

        Public Property NeedToShowTheForm() As Boolean
            Get
                Return Me._needToShowTheForm
            End Get
            Set(ByVal value As Boolean)
                Me._needToShowTheForm = value
            End Set
        End Property

        Public Shared Sub Find(ByVal backgroundWorker As System.ComponentModel.BackgroundWorker, ByVal e As System.ComponentModel.DoWorkEventArgs)
            _worker = backgroundWorker
            _eventArgs = e

            Dim searchData As SearchDescriptor = e.Argument

            searchData.ResultNode = New TreeNode()

            If (searchData.CheckWindows) Then
                If (searchData.CheckTabs) Then
                    If (searchData.CheckHidden) Then
                        Search_Windows_Tabs_HTML(searchData)
                    Else
                        Search_Windows_Tabs_Text(searchData)
                    End If
                Else
                    If (searchData.CheckHidden) Then
                        Search_Windows_Tab_HTML(searchData)
                    Else
                        Search_Windows_Tab_Text(searchData)
                    End If
                End If
            Else
                If (searchData.CheckTabs) Then
                    If (searchData.CheckHidden) Then
                        Search_Window_Tabs_HTML(searchData)
                    Else
                        Search_Window_Tabs_Text(searchData)
                    End If
                Else
                    If (searchData.CheckHidden) Then
                        Search_Window_Tab_HTML(searchData)
                    Else
                        Search_Window_Tab_Text(searchData)
                    End If
                End If
            End If
            e.Result = searchData
        End Sub

        Public Sub Navigate(ByVal _node As TreeNode)
            Dim windowInfo As WindowInfoTag = CType(_node.Parent.Tag, WindowInfoTag)

            If Not (windowInfo Is Nothing) Then
                Dim _module As IEModule = Nothing
                Dim m As IEModule = Nothing
                Dim modules As ArrayList = ADXIEModule.GetModulesByTypeName(Me.GetType().FullName)
                For i As Integer = 0 To modules.Count - 1
                    m = modules(i)
                    If ((m.NativeWindowHandle = windowInfo.NativeWindowHandle) And (m.MainWindowHandle.ToInt64() = windowInfo.HWND.ToInt64())) Then
                        _module = m
                        Exit For
                    End If
                Next

                If (_module IsNot Nothing) Then
                    If (TypeOf (_node.Tag) Is Integer) Then
                        Dim position As Integer = CType(_node.Tag, Integer)
                        If (IsWindow(windowInfo.HWND)) Then
                            Dim selectable As Boolean = True
                            If Not _module.IsSelectableText(position, windowInfo.Term, CType(windowInfo.Flags, Integer)) Then
                                selectable = False
                                System.Windows.Forms.MessageBox.Show(New WindowHandle(Me.ParentHandle), _
                                    "Text cannot be highlighted. For example, it might be hidden.", _
                                    "Advanced search", MessageBoxButtons.OK, MessageBoxIcon.Information)
                            End If
                            If (selectable) Then
                                ShowFrame(windowInfo.HWND)
                                If Not IsWindowVisible(_module.ParentHandle) Then
                                    _module.TabActivate()
                                End If
                            End If
                        End If
                    End If

                    If (TypeOf (_node.Tag) Is HtmlInfoTag) Then
                        SendMessageToAll(Constant.WM_CLOSE_FORMS, IntPtr.Zero, IntPtr.Zero)
                        Dim htmlInfo As HtmlInfoTag = CType(_node.Tag, HtmlInfoTag)
                        If Not (htmlInfo Is Nothing) Then
                            If (IsWindow(windowInfo.HWND)) Then
                                ShowFrame(windowInfo.HWND)
                                _module.Line = htmlInfo.Line
                                _module.Position = htmlInfo.Position
                                _module.Term = windowInfo.Term

                                If (Not IsWindowVisible(_module.ParentHandle)) Then
                                    _module.NeedToShowTheForm = True
                                    _module.TabActivate()
                                Else
                                    SendMessageToAll(Constant.WM_SHOW_HTML_FORM, _module.ParentHandle, IntPtr.Zero)
                                End If
                            End If
                        End If
                    End If
                End If
            End If
        End Sub
        Public Sub RefreshTree(ByVal tree As TreeView, ByVal threadID As Integer)
            For Each node As TreeNode In tree.Nodes
                Dim tag As WindowInfoTag = node.Tag
                If ((Not tag Is Nothing) And (tag.ThreadID = threadID)) Then
                    tree.Nodes.Remove(node)
                End If
            Next
        End Sub
        Private Sub UpdateProgress(ByVal mainProgress As Integer, ByVal position As Integer, ByVal count As Integer)
            Dim percent As Integer = System.Convert.ToInt32((System.Convert.ToDouble(position) / count) * 100)
            _worker.ReportProgress(mainProgress, percent)
        End Sub
        Public Sub Highlight(ByVal form As ProgressForm, ByVal resultNode As TreeNode, ByVal searchData As SearchDescriptor)
            Dim modulecount As Integer = GetModuleCount()
            Dim _module As IEModule = Nothing
            For i As Integer = 0 To resultNode.Nodes.Count - 1
                Dim percent As Integer = System.Convert.ToInt32(System.Convert.ToDouble(i) / resultNode.Nodes.Count * 100)
                Dim root As TreeNode = resultNode.Nodes(i)
                Dim wtag As WindowInfoTag = root.Tag
                Try
                    _module = GetModuleByThread(wtag.ThreadID)
                Catch
                End Try
                If Not _module Is Nothing Then
                    For Each leaf As TreeNode In root.Nodes
                        _module.HighlightHtmlPageElements(IsHighlighted, CType(leaf.Tag, Integer), CType(wtag.Flags, Integer), searchData.Term)
                        form.progressBar.Increment(percent - form.progressBar.Value)
                    Next
                End If
            Next
            form.progressBar.Value = 100
            Me._isHighlighted = Not Me._isHighlighted
        End Sub
        Private Sub HighlightTextRange(ByVal range As mshtml.IHTMLTxtRange, ByVal isHighlight As Boolean)
            Dim settings As GlobalSettings = GlobalData.Instance.Settings
            If Not (settings Is Nothing) Then
                If (_isHighlighted) Then
                    RemoveHTML(settings, range)
                Else
                    Dim htmlToInject = BuildHTML(settings, range)
                    If Not (String.IsNullOrEmpty(htmlToInject)) Then
                        range.pasteHTML(htmlToInject)
                    End If
                End If
            End If
        End Sub
        Private Function BuildHTML(ByVal settings As GlobalSettings, ByVal range As mshtml.IHTMLTxtRange) As String
            Dim background As String = settings.BackgroundColor.R.ToString("X2") + settings.BackgroundColor.G.ToString("X2") + settings.BackgroundColor.B.ToString("X2")
            Dim textColor As String = settings.TextColor.R.ToString("X2") + settings.TextColor.G.ToString("X2") + settings.TextColor.B.ToString("X2")
            Dim isEmpty As Boolean = False
            Dim builder As StringBuilder = New StringBuilder()
            builder.Append("<span id=advanced_search style=""background:#")
            builder.Append(background)
            builder.Append("; color:#")
            builder.Append(textColor)
            builder.Append(""">")

            If (settings.IsHightlightNonVisible) Then
                If (settings.IsItalic) Then
                    If (settings.IsBold) Then
                        builder.Append("<i><b>")
                        builder.Append(range.text)
                        builder.Append("</b></i></span>")
                    Else
                        builder.Append("<i>")
                        builder.Append(range.text)
                        builder.Append("</i></span>")
                    End If
                Else
                    If (settings.IsBold) Then
                        builder.Append("<b>")
                        builder.Append(range.text)
                        builder.Append("</b></span>")
                    Else
                        builder.Append(range.text)
                        builder.Append("</span>")
                    End If
                End If
            Else
                Dim element As mshtml.IHTMLElement = range.parentElement()
                If (element.offsetTop > Constant.NotFound And element.offsetLeft > Constant.NotFound And element.offsetHeight > Constant.Ok And element.offsetWidth > Constant.Ok) Then
                    If (settings.IsItalic) Then
                        If (settings.IsBold) Then
                            builder.Append("<i><b>")
                            builder.Append(range.text)
                            builder.Append("</b></i></span>")
                        Else
                            builder.Append("<i>")
                            builder.Append(range.text)
                            builder.Append("</i></span>")
                        End If
                    Else
                        If (settings.IsBold) Then
                            builder.Append("<b>")
                            builder.Append(range.text)
                            builder.Append("</b></span>")
                        Else
                            builder.Append(range.text)
                            builder.Append("</span>")
                        End If
                    End If
                Else
                    isEmpty = True
                End If
                Marshal.ReleaseComObject(element)
            End If
            If (isEmpty) Then
                Return String.Empty
            Else
                Return builder.ToString()
            End If
        End Function
        Private Sub RemoveHTML(ByVal settings As GlobalSettings, ByVal range As mshtml.IHTMLTxtRange)
            Dim element As mshtml.IHTMLElement = range.parentElement()
            If (settings.IsHightlightNonVisible) Then
                If (settings.IsBold) Then
                    If (settings.IsItalic) Then
                        RemoveBIS(element, range)
                    Else
                        RemoveBS(element, range)
                    End If
                Else
                    If (settings.IsItalic) Then
                        RemoveIS(element, range)
                    Else
                        RemoveS(element, range)
                    End If
                End If
            Else
                If (element.offsetTop > Constant.NotFound And element.offsetLeft > Constant.NotFound And element.offsetHeight > Constant.Ok And element.offsetWidth > Constant.Ok) Then
                    If (settings.IsBold) Then
                        If (settings.IsItalic) Then
                            RemoveBIS(element, range)
                        Else
                            RemoveBS(element, range)
                        End If
                    Else
                        If (settings.IsItalic) Then
                            RemoveIS(element, range)
                        Else
                            RemoveS(element, range)
                        End If
                    End If
                End If
            End If
            Marshal.ReleaseComObject(element)
        End Sub

        Private Sub RemoveS(ByVal element As mshtml.IHTMLElement, ByVal range As mshtml.IHTMLTxtRange)
            If (element.tagName = "SPAN") Then
                If (element.getAttribute("id", 2).ToString() = "advanced_search") Then
                    element.outerHTML = range.text 'targetTerm
                End If
            End If
        End Sub
        Private Sub RemoveIS(ByVal element As mshtml.IHTMLElement, ByVal range As mshtml.IHTMLTxtRange)
            If (element.tagName = "I") Then
                Dim elem As mshtml.IHTMLElement = element.parentElement
                If (elem.tagName = "SPAN" And elem.getAttribute("id", 2).ToString() = "advanced_search") Then
                    elem.outerHTML = range.text 'targetTerm
                End If
                Marshal.ReleaseComObject(elem)
            End If
        End Sub
        Private Sub RemoveBS(ByVal element As mshtml.IHTMLElement, ByVal range As mshtml.IHTMLTxtRange)
            If (element.tagName = "B") Then
                Dim elem As mshtml.IHTMLElement = element.parentElement
                If (elem.tagName = "SPAN" And elem.getAttribute("id", 2).ToString() = "advanced_search") Then
                    elem.outerHTML = range.text 'targetTerm
                End If
                Marshal.ReleaseComObject(elem)
            End If
        End Sub
        Private Sub RemoveBIS(ByVal element As mshtml.IHTMLElement, ByVal range As mshtml.IHTMLTxtRange)
            If (element.tagName = "B") Then
                Dim elem1 As mshtml.IHTMLElement = element.parentElement
                If (elem1.tagName = "I") Then
                    Dim elem2 As mshtml.IHTMLElement = elem1.parentElement
                    If (elem2.tagName = "SPAN" And elem2.getAttribute("id", 2).ToString() = "advanced_search") Then
                        elem2.outerHTML = range.text 'targetTerm
                    End If
                    Marshal.ReleaseComObject(elem2)
                End If
                Marshal.ReleaseComObject(elem1)
            End If
        End Sub

        Public Shared Function Searching_Windows_Tabs_Text(ByRef searchData As SearchDescriptor) As Root

            Dim root As Root = Nothing

            Dim moduleDesc As ModuleDescriptor = searchData.Modules(searchData.CurrentModuleIndex)

            If moduleDesc.HTMLDoc IsNot Nothing Then
                Dim body As mshtml.IHTMLElement = moduleDesc.HTMLDoc.body
                If ((body IsNot Nothing) And (Not String.IsNullOrEmpty(body.innerText))) Then
                    Dim positions As List(Of Integer) = Nothing
                    If (searchData.CheckCase) Then
                        If (searchData.CheckWholeWord) Then
                            positions = VisibleContent.CaseSensitive.WholeWord.AdvancedSearchEngine.Contains(moduleDesc.HTMLDoc.body.innerText, searchData.Term)
                            searchData.Flags = SearchFlags.ieMatchCase Or SearchFlags.ieMatchWholeWordsOnly
                        Else
                            positions = VisibleContent.CaseSensitive.WordAsPart.AdvancedSearchEngine.Contains(moduleDesc.HTMLDoc.body.innerText, searchData.Term)
                            searchData.Flags = SearchFlags.ieMatchCase Or SearchFlags.ieMatchPartialWords
                        End If
                    Else
                        If (searchData.CheckWholeWord) Then
                            positions = VisibleContent.CaseInsensetive.WholeWord.AdvancedSearchEngine.Contains(moduleDesc.HTMLDoc.body.innerText, searchData.Term)
                            searchData.Flags = SearchFlags.ieMatchWholeWordsOnly
                        Else
                            positions = VisibleContent.CaseInsensetive.WordAsPart.AdvancedSearchEngine.Contains(moduleDesc.HTMLDoc.body.innerText, searchData.Term)
                            searchData.Flags = SearchFlags.ieMatchPartialWords
                        End If
                    End If

                    root = CollectTextNodes(positions, searchData)

                    Marshal.ReleaseComObject(body)
                    body = Nothing
                End If
            End If
            Return root
        End Function
        Public Shared Function Searching_Windows_Tab_Text(ByRef searchData As SearchDescriptor) As Root
            Dim root As Root = Nothing
            Dim moduleDesc As ModuleDescriptor = searchData.Modules(searchData.CurrentModuleIndex)

            If (IsWindowVisible(moduleDesc.MainWnd)) Then
                If moduleDesc.HTMLDoc IsNot Nothing Then
                    Dim body As mshtml.IHTMLElement = moduleDesc.HTMLDoc.body
                    If ((body IsNot Nothing) And (Not String.IsNullOrEmpty(body.innerText))) Then
                        Dim positions As List(Of Integer) = Nothing
                        If (searchData.CheckCase) Then
                            If (searchData.CheckWholeWord) Then
                                positions = VisibleContent.CaseSensitive.WholeWord.AdvancedSearchEngine.Contains(moduleDesc.HTMLDoc.body.innerText, searchData.Term)
                                searchData.Flags = SearchFlags.ieMatchCase Or SearchFlags.ieMatchWholeWordsOnly
                            Else
                                positions = VisibleContent.CaseSensitive.WordAsPart.AdvancedSearchEngine.Contains(moduleDesc.HTMLDoc.body.innerText, searchData.Term)
                                searchData.Flags = SearchFlags.ieMatchCase Or SearchFlags.ieMatchPartialWords
                            End If
                        Else
                            If (searchData.CheckWholeWord) Then
                                positions = VisibleContent.CaseInsensetive.WholeWord.AdvancedSearchEngine.Contains(moduleDesc.HTMLDoc.body.innerText, searchData.Term)
                                searchData.Flags = SearchFlags.ieMatchWholeWordsOnly
                            Else

                                positions = VisibleContent.CaseInsensetive.WordAsPart.AdvancedSearchEngine.Contains(moduleDesc.HTMLDoc.body.innerText, searchData.Term)
                                searchData.Flags = SearchFlags.ieMatchPartialWords
                            End If
                        End If

                        root = CollectTextNodes(positions, searchData)

                        Marshal.ReleaseComObject(body)
                        body = Nothing
                    End If
                End If
            End If
            Return root
        End Function
        Public Shared Function Searching_Window_Tabs_Text(ByRef searchData As SearchDescriptor) As Root
            Dim root As Root = Nothing
            Dim positions As List(Of Integer) = Nothing

            Dim moduleDesc As ModuleDescriptor = searchData.Modules(searchData.CurrentModuleIndex)

            Dim body As mshtml.IHTMLElement = moduleDesc.HTMLDoc.body
            If ((body IsNot Nothing) And (Not String.IsNullOrEmpty(body.innerText))) Then
                If (searchData.CheckCase) Then
                    If (searchData.CheckWholeWord) Then
                        positions = VisibleContent.CaseSensitive.WholeWord.AdvancedSearchEngine.Contains(moduleDesc.HTMLDoc.body.innerText, searchData.Term)
                        searchData.Flags = SearchFlags.ieMatchCase Or SearchFlags.ieMatchWholeWordsOnly
                    Else

                        positions = VisibleContent.CaseSensitive.WordAsPart.AdvancedSearchEngine.Contains(moduleDesc.HTMLDoc.body.innerText, searchData.Term)
                        searchData.Flags = SearchFlags.ieMatchCase Or SearchFlags.ieMatchPartialWords
                    End If
                Else
                    If (searchData.CheckWholeWord) Then
                        positions = VisibleContent.CaseInsensetive.WholeWord.AdvancedSearchEngine.Contains(moduleDesc.HTMLDoc.body.innerText, searchData.Term)
                        searchData.Flags = SearchFlags.ieMatchWholeWordsOnly
                    Else
                        positions = VisibleContent.CaseInsensetive.WordAsPart.AdvancedSearchEngine.Contains(moduleDesc.HTMLDoc.body.innerText, searchData.Term)
                        searchData.Flags = SearchFlags.ieMatchPartialWords
                    End If
                End If
                root = CollectTextNodes(positions, searchData)

                Marshal.ReleaseComObject(body)
                body = Nothing
            End If
            Return root
        End Function

        Private Shared Sub Search_Window_Tab_HTML(ByRef searchData As SearchDescriptor)

            Dim moduleDesc As ModuleDescriptor = searchData.Modules(searchData.CurrentModuleIndex)

            If Not (moduleDesc.HTMLDoc Is Nothing) Then
                moduleDesc.Form = New HTMLForm()
                moduleDesc.Form.Text = moduleDesc.HTMLDoc.title
                Dim element As mshtml.IHTMLElement = moduleDesc.HTMLDoc.documentElement
                moduleDesc.Form.richHtmlText.Text = element.outerHTML

                Dim positions As List(Of Integer) = Nothing
                Dim nodes As List(Of Node) = New List(Of Node)

                Marshal.ReleaseComObject(element)

                Dim root As Root = Nothing

                If (CancelOperationOrReportUI(SearchProgress.Initializing)) Then Return

                Dim length As Integer = moduleDesc.Form.richHtmlText.Lines.Length

                If (searchData.CheckCase) Then
                    If (searchData.CheckWholeWord) Then
                        For line As Integer = 0 To length - 1
                            positions = VisibleContent.CaseSensitive.WholeWord.AdvancedSearchEngine.Contains(moduleDesc.Form.richHtmlText.Lines(line), searchData.Term)

                            If (positions.Count > Constant.Ok) Then
                                For Each pos As Integer In positions
                                    nodes.Add(New Node(moduleDesc.Form.richHtmlText.Lines(line), moduleDesc.Form.richHtmlText.Lines(line), 0, New HtmlInfoTag(line, pos)))
                                    If IsCancelled Then Return
                                Next
                                If (CancelOperationOrReportUI(SearchProgress.Searching, System.Convert.ToInt32((Convert.ToDouble(line) / length) * 100))) Then Return
                            End If
                        Next
                        If (nodes.Count > Constant.Ok) Then
                            root = New Root(moduleDesc.HTMLDoc.title, nodes, New WindowInfoTag(moduleDesc, searchData.Term, searchData.Flags))
                        End If
                    Else
                        For line As Integer = 0 To length - 1
                            positions = VisibleContent.CaseSensitive.WordAsPart.AdvancedSearchEngine.Contains(moduleDesc.Form.richHtmlText.Lines(line), searchData.Term)
                            If (positions.Count > Constant.Ok) Then
                                For Each pos As Integer In positions
                                    nodes.Add(New Node(moduleDesc.Form.richHtmlText.Lines(line), moduleDesc.Form.richHtmlText.Lines(line), 0, New HtmlInfoTag(line, pos)))
                                    If (IsCancelled) Then Return
                                Next

                                If (CancelOperationOrReportUI(SearchProgress.Searching, System.Convert.ToInt32((Convert.ToDouble(line) / length) * 100))) Then Return
                            End If
                        Next
                        If (nodes.Count > Constant.Ok) Then
                            root = New Root(moduleDesc.HTMLDoc.title, nodes, New WindowInfoTag(moduleDesc, searchData.Term, searchData.Flags))
                        End If
                    End If

                Else
                    If (searchData.CheckWholeWord) Then
                        For line As Integer = 0 To length - 1
                            positions = VisibleContent.CaseInsensetive.WholeWord.AdvancedSearchEngine.Contains(moduleDesc.Form.richHtmlText.Lines(line), searchData.Term)
                            If (positions.Count > Constant.Ok) Then
                                For Each pos As Integer In positions
                                    nodes.Add(New Node(moduleDesc.Form.richHtmlText.Lines(line), moduleDesc.Form.richHtmlText.Lines(line), 0, New HtmlInfoTag(line, pos)))
                                    If (IsCancelled) Then Return
                                Next
                                If (CancelOperationOrReportUI(SearchProgress.Searching, System.Convert.ToInt32((Convert.ToDouble(line) / length) * 100))) Then Return
                            End If
                        Next
                        If (nodes.Count > Constant.Ok) Then
                            root = New Root(moduleDesc.HTMLDoc.title, nodes, New WindowInfoTag(moduleDesc, searchData.Term, searchData.Flags))
                        End If
                    Else
                        For line As Integer = 0 To length - 1
                            positions = VisibleContent.CaseInsensetive.WordAsPart.AdvancedSearchEngine.Contains(moduleDesc.Form.richHtmlText.Lines(line), searchData.Term)
                            If (positions.Count > Constant.Ok) Then
                                For Each pos As Integer In positions
                                    nodes.Add(New Node(moduleDesc.Form.richHtmlText.Lines(line), moduleDesc.Form.richHtmlText.Lines(line), 0, New HtmlInfoTag(line, pos)))
                                    If (IsCancelled) Then Return
                                Next
                                If (CancelOperationOrReportUI(SearchProgress.Searching, System.Convert.ToInt32((Convert.ToDouble(line) / length) * 100))) Then Return
                            End If
                        Next
                    End If
                    If (nodes.Count > Constant.Ok) Then
                        root = New Root(moduleDesc.HTMLDoc.title, nodes, New WindowInfoTag(moduleDesc, searchData.Term, searchData.Flags))
                    End If
                End If
                If root IsNot Nothing Then

                    Dim treeNode As TreeNode = New TreeNode(root.Title)
                    treeNode.Tag = root.WindowInfo

                    Dim treeNodes As List(Of TreeNode) = New List(Of TreeNode)(root.Nodes.Count)

                    For Each nodeInTheList As Node In root.Nodes
                        Dim leaf As TreeNode = New TreeNode(nodeInTheList.InnerText)
                        leaf.ToolTipText = nodeInTheList.ToolTipText
                        leaf.Tag = nodeInTheList.HtmlTag
                        treeNodes.Add(leaf)
                    Next

                    treeNode.Nodes.AddRange(treeNodes.ToArray())
                    searchData.ResultNode.Nodes.Add(treeNode)
                End If

                If (element IsNot Nothing) Then Marshal.ReleaseComObject(element)
                element = Nothing

                If (CancelOperationOrReportUI(SearchProgress.Done, SearchProgress.Done)) Then Return
            End If
        End Sub
        Private Shared Sub Search_Window_Tab_Text(ByRef searchData As SearchDescriptor)
            If (searchData.Modules.Count > 0) Then
                searchData.CurrentModuleIndex = 0

                Dim element As mshtml.IHTMLElement = searchData.Modules(searchData.CurrentModuleIndex).HTMLDoc.body
                If ((Not (element Is Nothing)) And (Not (String.IsNullOrEmpty(element.innerText)))) Then

                    Dim positions As List(Of Integer) = Nothing

                    Dim body As String = element.innerText
                    Marshal.ReleaseComObject(element)

                    If (CancelOperationOrReportUI(SearchProgress.Initializing)) Then Return

                    If (searchData.CheckCase) Then
                        If (searchData.CheckWholeWord) Then
                            positions = VisibleContent.CaseSensitive.WholeWord.AdvancedSearchEngine.Contains(body, searchData.Term)
                            searchData.Flags = SearchFlags.ieMatchCase Or SearchFlags.ieMatchWholeWordsOnly
                        Else
                            positions = VisibleContent.CaseSensitive.WordAsPart.AdvancedSearchEngine.Contains(body, searchData.Term)
                            searchData.Flags = SearchFlags.ieMatchCase Or SearchFlags.ieMatchPartialWords
                        End If
                    Else
                        If (searchData.CheckWholeWord) Then
                            positions = VisibleContent.CaseInsensetive.WholeWord.AdvancedSearchEngine.Contains(body, searchData.Term)
                            searchData.Flags = SearchFlags.ieMatchWholeWordsOnly
                        Else
                            positions = VisibleContent.CaseInsensetive.WordAsPart.AdvancedSearchEngine.Contains(body, searchData.Term)
                            searchData.Flags = SearchFlags.ieMatchPartialWords
                        End If
                    End If

                    If (CancelOperationOrReportUI(SearchProgress.Searching)) Then Return

                    Dim moduleNode As Root = CollectTextNodes(positions, searchData)

                    If moduleNode IsNot Nothing Then
                        Dim treeNode As TreeNode = New TreeNode(moduleNode.Title)
                        treeNode.Tag = moduleNode.WindowInfo

                        Dim treeNodes As List(Of TreeNode) = New List(Of TreeNode)(moduleNode.Nodes.Count)

                        For Each nodeInTheList As Node In moduleNode.Nodes
                            Dim leaf As TreeNode = New TreeNode(nodeInTheList.InnerText)
                            leaf.ToolTipText = nodeInTheList.ToolTipText
                            leaf.Tag = nodeInTheList.Position
                            treeNodes.Add(leaf)
                        Next

                        treeNode.Nodes.AddRange(treeNodes.ToArray())
                        searchData.ResultNode.Nodes.Add(treeNode)
                    End If

                    Marshal.ReleaseComObject(element)
                    element = Nothing

                    If (CancelOperationOrReportUI(SearchProgress.Done, SearchProgress.Done)) Then Return
                End If
            End If
        End Sub
        Private Shared Sub Search_Window_Tabs_HTML(ByRef searchData As SearchDescriptor)
            For currentModule As Integer = 0 To searchData.Modules.Count - 1
                searchData.CurrentModuleIndex = currentModule

                Dim root As Root = CollectHtmlNodes(searchData)

                If root IsNot Nothing Then
                    Dim treeNode As TreeNode = New TreeNode(root.Title)
                    treeNode.Tag = root.WindowInfo
                    Dim treeNodes As List(Of TreeNode) = New List(Of TreeNode)(root.Nodes.Count)

                    For Each nodeInTheList As Node In root.Nodes
                        Dim leaf As TreeNode = New TreeNode(nodeInTheList.InnerText)
                        leaf.ToolTipText = nodeInTheList.ToolTipText
                        leaf.Tag = nodeInTheList.HtmlTag
                        treeNodes.Add(leaf)
                    Next

                    treeNode.Nodes.AddRange(treeNodes.ToArray())
                    searchData.ResultNode.Nodes.Add(treeNode)
                End If
                If (CancelOperationOrReportUI(System.Convert.ToInt32(System.Convert.ToDouble(currentModule) / searchData.Modules.Count * 100))) Then Return
            Next
            If (CancelOperationOrReportUI(SearchProgress.Done, SearchProgress.Done)) Then Return
        End Sub
        Private Shared Sub Search_Window_Tabs_Text(ByRef searchData As SearchDescriptor)
            For currentModule As Integer = 0 To searchData.Modules.Count - 1
                searchData.CurrentModuleIndex = currentModule

                Dim moduleNode As Root = Searching_Window_Tabs_Text(searchData)

                If moduleNode IsNot Nothing Then

                    Dim treeNode As TreeNode = New TreeNode(moduleNode.Title)
                    treeNode.Tag = moduleNode.WindowInfo
                    Dim treeNodes As List(Of TreeNode) = New List(Of TreeNode)(moduleNode.Nodes.Count)

                    For Each nodeInTheList As Node In moduleNode.Nodes
                        Dim leaf As TreeNode = New TreeNode(nodeInTheList.InnerText)
                        leaf.ToolTipText = nodeInTheList.ToolTipText
                        leaf.Tag = nodeInTheList.Position
                        treeNodes.Add(leaf)
                    Next

                    treeNode.Nodes.AddRange(treeNodes.ToArray())
                    searchData.ResultNode.Nodes.Add(treeNode)
                End If

                If (CancelOperationOrReportUI(System.Convert.ToInt32(System.Convert.ToDouble(currentModule) / searchData.Modules.Count * 100))) Then Return
            Next
            If (CancelOperationOrReportUI(SearchProgress.Done, SearchProgress.Done)) Then Return
        End Sub
        Private Shared Sub Search_Windows_Tabs_HTML(ByRef searchData As SearchDescriptor)
            For currentModule As Integer = 0 To searchData.Modules.Count - 1
                searchData.CurrentModuleIndex = currentModule

                Dim Root As Root = CollectHtmlNodes(searchData)
                If (Root IsNot Nothing) Then
                    Dim treeNode As TreeNode = New TreeNode(Root.Title)
                    treeNode.Tag = Root.WindowInfo
                    Dim treeNodes As List(Of TreeNode) = New List(Of TreeNode)(Root.Nodes.Count)

                    For Each nodeInTheList As Node In Root.Nodes
                        Dim leaf As TreeNode = New TreeNode(nodeInTheList.InnerText)
                        leaf.ToolTipText = nodeInTheList.ToolTipText
                        leaf.Tag = nodeInTheList.HtmlTag
                        treeNodes.Add(leaf)
                    Next

                    treeNode.Nodes.AddRange(treeNodes.ToArray())
                    searchData.ResultNode.Nodes.Add(treeNode)
                End If
                If (CancelOperationOrReportUI(System.Convert.ToInt32(System.Convert.ToDouble(currentModule) / searchData.Modules.Count * 100))) Then Return
            Next
            If (CancelOperationOrReportUI(SearchProgress.Done, SearchProgress.Done)) Then Return
        End Sub
        Private Shared Sub Search_Windows_Tabs_Text(ByRef searchData As SearchDescriptor)
            For currentModule As Integer = 0 To searchData.Modules.Count - 1
                searchData.CurrentModuleIndex = currentModule

                Dim moduleNode As Root = Searching_Windows_Tabs_Text(searchData)

                If (moduleNode IsNot Nothing) Then
                    Dim treeNode As TreeNode = New TreeNode(moduleNode.Title)
                    treeNode.Tag = moduleNode.WindowInfo
                    Dim treeNodes As List(Of TreeNode) = New List(Of TreeNode)(moduleNode.Nodes.Count)

                    For Each nodeInTheList As Node In moduleNode.Nodes
                        Dim leaf As TreeNode = New TreeNode(nodeInTheList.InnerText)
                        leaf.ToolTipText = nodeInTheList.ToolTipText
                        leaf.Tag = nodeInTheList.Position
                        treeNodes.Add(leaf)
                    Next

                    treeNode.Nodes.AddRange(treeNodes.ToArray())
                    searchData.ResultNode.Nodes.Add(treeNode)
                End If
                If (CancelOperationOrReportUI(System.Convert.ToInt32(System.Convert.ToDouble(currentModule) / searchData.Modules.Count * 100))) Then Return
            Next
            If (CancelOperationOrReportUI(SearchProgress.Done, SearchProgress.Done)) Then Return
        End Sub
        Private Shared Sub Search_Windows_Tab_HTML(ByRef searchData As SearchDescriptor)
            For currentModule As Integer = 0 To searchData.Modules.Count - 1
                searchData.CurrentModuleIndex = currentModule
                If (IsWindowVisible(searchData.Modules(currentModule).TabWnd)) Then
                    If (CancelOperationOrReportUI(System.Convert.ToInt32(System.Convert.ToDouble(currentModule) / searchData.Modules.Count * 100))) Then Return
                    Dim root As Root = CollectHtmlNodes(searchData)
                    If (root IsNot Nothing) Then
                        Dim treeNode As TreeNode = New TreeNode(root.Title)
                        treeNode.Tag = root.WindowInfo
                        Dim treeNodes As List(Of TreeNode) = New List(Of TreeNode)(root.Nodes.Count)

                        For Each nodeInTheList As Node In root.Nodes
                            Dim leaf As TreeNode = New TreeNode(nodeInTheList.InnerText)
                            leaf.ToolTipText = nodeInTheList.ToolTipText
                            leaf.Tag = nodeInTheList.HtmlTag
                            treeNodes.Add(leaf)
                        Next

                        treeNode.Nodes.AddRange(treeNodes.ToArray())
                        searchData.ResultNode.Nodes.Add(treeNode)
                    End If
                End If
                If (CancelOperationOrReportUI(System.Convert.ToInt32(System.Convert.ToDouble(currentModule) / searchData.Modules.Count * 100))) Then Return
            Next
            If (CancelOperationOrReportUI(SearchProgress.Done, SearchProgress.Done)) Then Return
        End Sub
        Private Shared Sub Search_Windows_Tab_Text(ByRef searchData As SearchDescriptor)
            For currentModule As Integer = 0 To searchData.Modules.Count - 1
                searchData.CurrentModuleIndex = currentModule

                Dim moduleNode As Root = Searching_Windows_Tab_Text(searchData)

                If (moduleNode IsNot Nothing) Then
                    Dim treeNode As TreeNode = New TreeNode(moduleNode.Title)
                    treeNode.Tag = moduleNode.WindowInfo
                    Dim treeNodes As List(Of TreeNode) = New List(Of TreeNode)(moduleNode.Nodes.Count)

                    For Each nodeInTheList As Node In moduleNode.Nodes
                        Dim leaf As TreeNode = New TreeNode(nodeInTheList.InnerText)
                        leaf.ToolTipText = nodeInTheList.ToolTipText
                        leaf.Tag = nodeInTheList.Position
                        treeNodes.Add(leaf)
                    Next

                    treeNode.Nodes.AddRange(treeNodes.ToArray())
                    searchData.ResultNode.Nodes.Add(treeNode)
                End If
                If (CancelOperationOrReportUI(System.Convert.ToInt32(System.Convert.ToDouble(currentModule) / searchData.Modules.Count * 100))) Then Return
            Next
            If (CancelOperationOrReportUI(SearchProgress.Done, SearchProgress.Done)) Then Return
        End Sub

        Private Shared Function CollectTextNodes(ByVal pos As List(Of Integer), ByRef searchData As SearchDescriptor) As Root
            Dim Root As Root = Nothing
            If pos Is Nothing Then Return Root

            Dim moduleDesc As ModuleDescriptor = searchData.Modules(searchData.CurrentModuleIndex)

            Dim documentElement As mshtml.IHTMLElement = moduleDesc.HTMLDoc.documentElement
            If ((documentElement IsNot Nothing) And (Not String.IsNullOrEmpty(documentElement.outerHTML))) Then

                Dim nodes As List(Of Node) = New List(Of Node)()
                Dim range As mshtml.IHTMLTxtRange = Nothing

                For position As Integer = 0 To pos.Count - 1
                    Dim sel As mshtml.IHTMLSelectionObject = moduleDesc.HTMLDoc.selection

                    If sel IsNot Nothing Then
                        sel.empty()
                        Marshal.ReleaseComObject(sel)
                    End If

                    Dim selectionObject As mshtml.IHTMLSelectionObject = moduleDesc.HTMLDoc.selection
                    Dim bodyElement As mshtml.IHTMLElement = moduleDesc.HTMLDoc.body
                    range = CType(selectionObject.createRange(), mshtml.IHTMLTxtRange)
                    range.moveToElementText(bodyElement)

                    For i As Integer = 1 To position
                        range.findText(searchData.Term, bodyElement.innerText.Length, CType(searchData.Flags, Integer))
                        range.moveStart("character", 1)
                    Next

                    range.findText(searchData.Term, bodyElement.innerText.Length, CType(searchData.Flags, Integer))
                    Dim parentElement As mshtml.IHTMLElement = range.parentElement()

                    Dim Node As Node = New Node(parentElement.innerText, moduleDesc.HTMLDoc.title, position, Nothing)
                    nodes.Add(Node)

                    Marshal.ReleaseComObject(parentElement)
                    parentElement = Nothing
                    Marshal.ReleaseComObject(bodyElement)
                    bodyElement = Nothing
                    Marshal.ReleaseComObject(selectionObject)
                    selectionObject = Nothing
                    Marshal.ReleaseComObject(range)
                    range = Nothing
                Next
                If nodes.Count > Constant.Ok Then
                    Root = New Root(moduleDesc.HTMLDoc.title, nodes, New WindowInfoTag(moduleDesc, searchData.Term, searchData.Flags))
                End If

                Marshal.ReleaseComObject(documentElement)
                documentElement = Nothing
            End If
            Return Root
        End Function
        Public Shared Function CollectHtmlNodes(ByRef searchData As SearchDescriptor) As Root

            Dim root As Root = Nothing
            Dim positions As List(Of Integer) = Nothing
            Dim nodes As List(Of Node) = New List(Of Node)()

            Dim moduleDesc As ModuleDescriptor = searchData.Modules(searchData.CurrentModuleIndex)

            moduleDesc.Form = New HTMLForm()
            Try
                If moduleDesc.HTMLDoc IsNot Nothing Then
                    moduleDesc.Form.Text = moduleDesc.HTMLDoc.title
                    Dim documentElement As mshtml.IHTMLElement = moduleDesc.HTMLDoc.documentElement
                    If ((documentElement IsNot Nothing) And (Not String.IsNullOrEmpty(documentElement.outerHTML))) Then
                        moduleDesc.Form.richHtmlText.Text = documentElement.outerHTML
                        Dim length As Integer = moduleDesc.Form.richHtmlText.Lines.Length
                        For line As Integer = 0 To length - 1
                            If (searchData.CheckCase) Then
                                If (searchData.CheckWholeWord) Then
                                    positions = VisibleContent.CaseSensitive.WholeWord.AdvancedSearchEngine.Contains(moduleDesc.Form.richHtmlText.Lines(line), searchData.Term)
                                    If (positions.Count > Constant.Ok) Then
                                        For Each pos As Integer In positions
                                            nodes.Add(New Node(moduleDesc.Form.richHtmlText.Lines(line), moduleDesc.Form.richHtmlText.Lines(line), 0, New HtmlInfoTag(line, pos)))
                                        Next
                                    End If
                                Else
                                    positions = VisibleContent.CaseSensitive.WordAsPart.AdvancedSearchEngine.Contains(moduleDesc.Form.richHtmlText.Lines(line), searchData.Term)
                                    If (positions.Count > Constant.Ok) Then
                                        For Each pos As Integer In positions
                                            nodes.Add(New Node(moduleDesc.Form.richHtmlText.Lines(line), moduleDesc.Form.richHtmlText.Lines(line), 0, New HtmlInfoTag(line, pos)))
                                        Next
                                    End If
                                End If
                            Else
                                If (searchData.CheckWholeWord) Then
                                    positions = VisibleContent.CaseInsensetive.WholeWord.AdvancedSearchEngine.Contains(moduleDesc.Form.richHtmlText.Lines(line), searchData.Term)
                                    If (positions.Count > Constant.Ok) Then
                                        For Each pos As Integer In positions
                                            nodes.Add(New Node(moduleDesc.Form.richHtmlText.Lines(line), moduleDesc.Form.richHtmlText.Lines(line), 0, New HtmlInfoTag(line, pos)))
                                        Next
                                    End If
                                Else
                                    positions = VisibleContent.CaseInsensetive.WordAsPart.AdvancedSearchEngine.Contains(moduleDesc.Form.richHtmlText.Lines(line), searchData.Term)
                                    If (positions.Count > Constant.Ok) Then
                                        For Each pos As Integer In positions
                                            nodes.Add(New Node(moduleDesc.Form.richHtmlText.Lines(line), moduleDesc.Form.richHtmlText.Lines(line), 0, New HtmlInfoTag(line, pos)))
                                        Next
                                    End If
                                End If
                            End If
                        Next
                    End If

                    If (nodes.Count > Constant.Ok) Then
                        root = New Root(moduleDesc.HTMLDoc.title, nodes, New WindowInfoTag(moduleDesc, searchData.Term, searchData.Flags))
                    End If

                    Marshal.ReleaseComObject(documentElement)
                    documentElement = Nothing
                End If
            Catch
            Finally
                If (moduleDesc.Form IsNot Nothing) Then
                    moduleDesc.Form.Dispose()
                    moduleDesc.Form = Nothing
                End If
            End Try
            Return root
        End Function

        Private Shared Function CancelOperationOrReportUI(ByVal percent As Integer, ByVal userState As Object) As Boolean
            Dim interrupted As Boolean = False
            If (_worker.CancellationPending) Then
                _eventArgs.Cancel = True
                interrupted = True
            Else
                _worker.ReportProgress(percent, userState)
            End If
            Return interrupted
        End Function
        Private Shared Function CancelOperationOrReportUI(ByVal percent As Integer) As Boolean
            Return CancelOperationOrReportUI(percent, Nothing)
        End Function
        Private Shared ReadOnly Property IsCancelled() As Boolean
            Get
                Dim retValue As Boolean = False
                If (_worker.CancellationPending) Then
                    retValue = True
                End If
                _eventArgs.Cancel = retValue
                Return retValue
            End Get
        End Property
        Public Property CheckCase() As Boolean
            Get
                Return Me._checkCase
            End Get
            Set(ByVal value As Boolean)
                Me._checkCase = value
            End Set
        End Property
        Public Property CheckHidden() As Boolean
            Get
                Return Me._checkHidden
            End Get
            Set(ByVal value As Boolean)
                Me._checkHidden = value
            End Set
        End Property
        Public Property CheckWholeWord() As Boolean
            Get
                Return Me._checkWholeWord
            End Get
            Set(ByVal value As Boolean)
                Me._checkWholeWord = value
            End Set
        End Property
        Public Property CheckTabs() As Boolean
            Get
                Return Me._checkTabs
            End Get
            Set(ByVal value As Boolean)
                Me._checkTabs = value
            End Set
        End Property
        Public Property CheckWindows() As Boolean
            Get
                Return Me._checkWindows
            End Get
            Set(ByVal value As Boolean)
                Me._checkWindows = value
            End Set
        End Property
        Public Property Term() As String
            Get
                Return Me.targetTerm
            End Get
            Set(ByVal value As String)
                Me.targetTerm = value
            End Set
        End Property
        Public ReadOnly Property IsHighlighted() As Boolean
            Get
                Return Me._isHighlighted
            End Get
        End Property

        Public Sub PrepareForm(ByVal line As Integer, ByVal position As Integer, ByVal term As String)
            Dim firstCharIndex As Integer = _form.richHtmlText.GetFirstCharIndexFromLine(line)
            _form.richHtmlText.Select(firstCharIndex + position, term.Length)
            _form.richHtmlText.ScrollToCaret()
        End Sub

        Public Sub CloseForm()
            If _form.Visible Then _form.Hide()
        End Sub

        Public Function IsSelectableText(ByVal number As Integer, ByVal term As String, ByVal flags As Integer) As Boolean
            Dim sFlags As SearchFlags = CType(flags, SearchFlags)

            Dim retValue As Boolean = True
            Dim selectionObject As mshtml.IHTMLSelectionObject = HTMLDocument.selection
            Dim range As mshtml.IHTMLTxtRange = CType(selectionObject.createRange(), mshtml.IHTMLTxtRange)
            Dim elementBody As mshtml.IHTMLElement = HTMLDocument.body

            Try
                range.moveToElementText(elementBody)
            Catch
                retValue = False
            End Try

            For i As Integer = 1 To number
                range.findText(term, elementBody.innerText.Length, CType(sFlags, Integer))
                range.moveStart("character", 1)
            Next
            range.findText(term, elementBody.innerText.Length, CType(sFlags, Integer))

            Marshal.ReleaseComObject(selectionObject)
            Marshal.ReleaseComObject(elementBody)

            Try
                range.select()
                range.scrollIntoView(True)
            Catch
                retValue = False
            End Try
            Return retValue
        End Function

        Public Sub HighlightHtmlPageElements(ByVal isHighlighted As Boolean, ByVal position As Integer, ByVal flags As Integer, ByVal term As String)
            Try
                Me.targetTerm = term
                Dim selection As mshtml.IHTMLSelectionObject = HTMLDocument.selection
                Dim range As mshtml.IHTMLTxtRange = CType(selection.createRange(), mshtml.IHTMLTxtRange)

                range.moveToElementText(HTMLDocument.body)
                For index As Integer = 0 To position - 1

                    range.findText(term, 30000, flags)
                    range.moveStart("character", 1)
                Next
                range.findText(term, 30000, flags)

                HighlightTextRange(range, isHighlighted)

                Marshal.ReleaseComObject(range)
                range = Nothing
                Marshal.ReleaseComObject(selection)
                selection = Nothing
            Catch ex As Exception
                System.Diagnostics.Debug.WriteLine(ex.Message)
            End Try
        End Sub

        Private Sub IEModule_OnSendMessage(ByVal e As ADXIESendMessageEventArgs) Handles MyBase.OnSendMessage
            If (e.Message = Constant.WM_CLOSE_FORMS) Then
                If (_form IsNot Nothing) Then
                    If _form.Visible Then _form.Hide()
                End If
            End If
            If (e.Message = Constant.WM_SHOW_HTML_FORM) Then
                If (ParentHandle = e.WParam) Then
                    If (Not IsWindowVisible(ParentHandle)) Then
                        NeedToShowTheForm = True
                        TabActivate()
                    Else
                        ShowForm()
                    End If
                End If
            End If
        End Sub

        Public Sub ShowForm()
            _form = New HTMLForm()
            _form.Text = HTMLDocument.title

            Dim element As mshtml.IHTMLElement = HTMLDocument.documentElement
            _form.richHtmlText.Text = element.outerHTML
            Marshal.ReleaseComObject(element)

            Dim firstCharIndex As Integer = _form.richHtmlText.GetFirstCharIndexFromLine(_line)
            _form.richHtmlText.Select(firstCharIndex + _position, Me.Term.Length)
            _form.richHtmlText.ScrollToCaret()

            _form.ShowDialog(Me)
            SetForegroundWindow(Me.MainWindowHandle)
        End Sub

        Private Sub IEModule_OnTabChanged(ByVal sender As System.Object, ByVal success As System.Boolean) Handles MyBase.OnTabChanged
            If needToShowTheForm Then
                NeedToShowTheForm = False
                ShowForm()
            End If
        End Sub

        Public Function GetHTMLText() As String
            Return HTMLDocument.documentElement.outerHTML
        End Function
    End Class
End Namespace
